#!/usr/bin/perl

############################################
##                                        ##
##           WebAdverts (Admin)           ##
##           by Darryl Burgdorf           ##
##       (e-mail burgdorf@awsd.com)       ##
##                                        ##
##             version: 2.14              ##
##         last modified: 1/19/00         ##
##           copyright (c) 2000           ##
##                                        ##
##    latest version is available from    ##
##        http://awsd.com/scripts/        ##
##                                        ##
############################################

# COPYRIGHT NOTICE:
#
# Copyright 2000 Darryl C. Burgdorf.  All Rights Reserved.
#
# This program is being distributed as shareware.  It may be used and
# modified by anyone, so long as this copyright notice and the header
# above remain intact, but any usage should be registered.  (See the
# program documentation for registration information.)  Selling the
# code for this program without prior written consent is expressly
# forbidden.  Obtain permission before redistributing this program
# over the Internet or in any other medium.  In all cases copyright
# and header must remain intact.
#
# This program is distributed "as is" and without warranty of any
# kind, either express or implied.  (Some states do not allow the
# limitation or exclusion of liability for incidental or consequential
# damages, so this notice may not apply to you.)  In no event shall
# the liability of Darryl C. Burgdorf and/or Affordable Web Space
# Design for any damages, losses and/or causes of action exceed the
# total amount paid by the user for this software.

# DEFINE THESE CONFIGURATION VARIABLES!

# The following variables should be set to define the locations
# and URLs of various files, as explained in the documentation,
# and to "tailer" the functioning of the script.

$adverts_dir = "/full/path/to/ads";
$admin_cgi = "http://foo.com/ads/ads_admin.pl";
$nonssi_cgi = "http://foo.com/ads/ads.pl";

# %nonssi_cgis = (
#   'Zone1','http://foo.com/ads/ads_1.pl',
#   'Zone2','http://foo.com/ads/ads_2.pl',
#   'Zone3','http://foo.com/ads/ads_3.pl',
# );

$UseLocking = 1;
$LogIP = 1;

$AdminDisplaySetup = 0;

$AllowUserEdit = 0;
$RequireAdminApproval = 1;

$LogAdminAccesses = 1;
$IgnoredIPs = "";

$UserUploadDir = "/full/path/to/bannerdir";
$UserUploadURL = "http://foo.com/bannerdir";
$MaxBannerSize = 20;

$DefaultDisplayRatio = 2;
$DefaultWeight = 1;
$DefaultBorder = 0;

$IFRAMEexchange = 1;
$JavaScriptExchange = 1;

$DefaultLinkAttribute = "TARGET=&quot;_blank&quot;";

$bodyspec = "BGCOLOR=\"#ffffff\" TEXT=\"#000000\"";
$fontspec = "FACE=\"Arial\"";
$MetaFile = "";
$header_file = "";
$footer_file = "";
$SSIRootDir = "";

$ExchangeName = "WebScripts Advertisers";
$ExchangeURL = "";
$ExchangeLogo = "";
$ExchangeLogoWidth = 60;
$ExchangeLogoHeight = 60;
$ExchangeLogoPosition = "";
$ExchangeBannerWidth = 468;
$ExchangeBannerHeight = 60;

$admin_name = "Administrator";
$email_address = "webadverts\@foo.com";
$mailprog = '/usr/sbin/sendmail';
$WEB_SERVER = "";
$SMTP_SERVER = "";

# use Socket;
# use Net::SMTP;

# NOTHING BELOW THIS LINE NEEDS TO BE ALTERED!

@months = (Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec);
$version = "2.14";
$cryptword = 0;
$time = time;

print "Content-type: text/html\n\n";

unless ($UseLocking) { &MasterLockOpen; }

if (($ENV{'REMOTE_ADDR'} =~ /\d+\.\d+\.\d+\.\d+/)
  && (!($ENV{'REMOTE_HOST'})
  || ($ENV{'REMOTE_HOST'} =~ /\d+\.\d+\.\d+\.\d+/))) {
	@domainbytes = split(/\./,$ENV{'REMOTE_ADDR'});
	$packaddr = pack("C4",@domainbytes);
	$resolvedip = (gethostbyaddr($packaddr, 2))[0];
	unless ($resolvedip =~
	  /^[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})$/) {
		$resolvedip = "";
	}
	if ($resolvedip) {
		$ENV{'REMOTE_HOST'} = $resolvedip;
	}
}
unless ($ENV{'REMOTE_HOST'}) {
	$ENV{'REMOTE_HOST'} = $ENV{'REMOTE_ADDR'};
}

if ($IgnoredIPs) {
	@ignoredips = split(/ /,$IgnoredIPs);
	foreach $ignoredip (@ignoredips) {
		if (($ENV{'REMOTE_HOST'} =~ /$ignoredip/i)
		  || ($ENV{'REMOTE_ADDR'} =~ /$ignoredip/i)) {
			&Header("WebAdverts Error!","Access Denied!");
			print "<P ALIGN=CENTER>Sorry, ";
			print "but you're not allowed access to admin functions.\n";
			&Footer("Access Denied");
		}
	}
}

if ($ENV{'CONTENT_TYPE'} =~ /^multipart\/form-data/) {
	if ($ENV{'CONTENT_TYPE'} =~ /boundary=(\"?([^\";,]+)\"?)*/) { $boundary = $1; }
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	@buffer = split(/\r\n/,$buffer);
	foreach $line (@buffer) {
		if ($line =~ /$boundary/) { $Current = ""; next; }
		if ($line =~ /Content-Disposition/) {
			if ($line =~ /^.+name\s*=\s*"*([^\s"]+).+$/) { $Current = $1; }
			$INPUT{$Current} = ""; next;
		}
		if ($line =~ /Content-Type/) {
			if ($line =~ /gif/) { $BannerType = "GIF"; }
			elsif (($line =~ /jpeg/) || ($line =~ /jpg/)) { $BannerType = "JPG"; }
			$Current = "BannerFile"; $INPUT{'BannerFile'} = ""; next;
		}
		if (($line eq "") && ($Current ne "BannerFile")) { next; }
		$INPUT{$Current} .= $line;
	}
}
else {
	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	@pairs = split(/&/, $buffer);
	foreach $pair (@pairs) {
		($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		if ($INPUT{$name}) { $INPUT{$name} = $INPUT{$name}." ".$value; }
		else { $INPUT{$name} = $value; }
	}
}

unless (-s "$adverts_dir/adcount.txt") {
	open (COUNT, ">$adverts_dir/adcount.txt");
	$lines[0] = 1;
	$lines[1] = "0";
	$lines[2] = $time;
	seek(COUNT, 0, 0);
	foreach $line (@lines) { print COUNT "$line\n"; }
	truncate (COUNT, tell(COUNT));
	close (COUNT);
}

if (!(-e "$adverts_dir/adlist.txt")) { &UpdateAdList; }

if ($ENV{'QUERY_STRING'} =~ /reginfo/i) { &reginfo; }
elsif ($ENV{'QUERY_STRING'} =~ /admin/i) { &adminintro; }
elsif ($INPUT{'getpass'}) { &GetPassword; }
elsif ($INPUT{'register'}) { &register; }
elsif ($INPUT{'edit'}) { &edit; }
elsif ($INPUT{'newuserpassword'}) { &NewUserPassword; }
elsif ($INPUT{'UserEdit'}) { &UserEdit; }
elsif ($INPUT{'uploadbanner'}) { &UploadBanner; }
elsif ($INPUT{'groupedit'}) { &groupedit; }
elsif ($INPUT{'del'}) { &del; }
elsif ($INPUT{'delgroup'}) { &delgroup; }
elsif ($INPUT{'newpass'}) { &newpass; }
elsif ($INPUT{'resetcount'}) { &resetcount; }
elsif ($INPUT{'editfinal'}) { &editfinal; }
elsif ($INPUT{'editgroupfinal'}) { &editgroupfinal; }
elsif ($INPUT{'delfinal'}) { &delfinal; }
elsif ($INPUT{'delgroupfinal'}) { &delgroupfinal; }
elsif ($INPUT{'reviewone'} eq "Define View") {
	if ($AdminDisplaySetup) { &defineview; }
	else {
		$INPUT{'whichtype'} = "pending established groups";
		$INPUT{'whichtime'} = "active expired disabled";
		$INPUT{'whichzone'} = "";
		&reviewall;
	}
}
elsif ($INPUT{'reviewone'} eq "Review All Accounts") { &reviewall; }
elsif ($INPUT{'reviewone'}) { &reviewone; }
elsif ($INPUT{'dailystats'}) { &dailystats; }
elsif ($INPUT{'monthlystats'}) { &monthlystats; }
elsif ($INPUT{'masteriplog'}) { &masteriplog; }
elsif ($INPUT{'iplog'}) { &iplog; }
elsif ($INPUT{'adminlog'}) { &adminlog; }
elsif ($INPUT{'listemail'}) { &ListEmail; }
else { &userintro; }

sub userintro {
	&Header("WebAdverts","WebAdverts Administrative Access");
	print "<P ALIGN=CENTER>To view the status of any single account ",
	  "or defined group,\n",
	  "<BR>enter its name and password:\n",
	  "<CENTER><FORM METHOD=POST ACTION=$admin_cgi>\n",
	  "<P><STRONG>Account or Group Name:</STRONG> ",
	  "<FONT FACE=\"Courier\"><INPUT TYPE=TEXT NAME=reviewone SIZE=15></FONT>\n",
	  "<BR><STRONG>Password:</STRONG> ",
	  "<FONT FACE=\"Courier\"><INPUT TYPE=PASSWORD NAME=password SIZE=15></FONT>\n",
	  "<P><INPUT TYPE=SUBMIT ",
	  "VALUE=\"Review Single Account or Group\">\n",
	  "</FORM></CENTER>\n";
	if ($AllowUserEdit) {
		print "<P><HR><P ALIGN=CENTER>To add your site to the exchange,\n",
		  "<BR>enter the name and password you wish to use:\n",
		  "<CENTER><FORM METHOD=POST ACTION=$admin_cgi>\n",
		  "<P><STRONG>Account Name:</STRONG> ",
		  "<FONT FACE=\"Courier\"><INPUT TYPE=TEXT NAME=reviewone SIZE=15></FONT>\n",
		  "<BR><STRONG>Password:</STRONG> ",
		  "<FONT FACE=\"Courier\"><INPUT TYPE=PASSWORD NAME=password SIZE=15></FONT>\n",
		  "<INPUT TYPE=HIDDEN NAME=newuser VALUE=yes>\n",
		  "<P><INPUT TYPE=SUBMIT ",
		  "VALUE=\"Create New Account\">\n",
		  "</FORM></CENTER>\n";
	}
	if ($mailprog) {
		print "<P><HR><P ALIGN=CENTER>If you've forgotten your password,\n",
		  "<BR>enter your account, and your password will be e-mailed to you:\n",
		  "<CENTER><FORM METHOD=POST ACTION=$admin_cgi>\n",
		  "<P><STRONG>Account Name:</STRONG> ",
		  "<FONT FACE=\"Courier\"><INPUT TYPE=TEXT NAME=getpass SIZE=15></FONT>\n",
		  "<P><INPUT TYPE=SUBMIT ",
		  "VALUE=\"Get Password\">\n",
		  "</FORM></CENTER>\n";
	}
	&Footer;
}

sub adminintro {
	open (PASSWORD, "<$adverts_dir/adpassword.txt");
	$password = <PASSWORD>;
	close (PASSWORD);
	chop ($password) if ($password =~ /\n$/);
	if (!$password) { &InitializePassword; }
	&Header("WebAdverts","WebAdverts Administrative Access");
	print "<P ALIGN=CENTER>To view the status of all accounts and ",
	  "access WebAdvert's main administrative functions,\n",
	  "<BR>input the administrative password:\n",
	  "<CENTER><FORM METHOD=POST ACTION=$admin_cgi>\n",
	  "<P><STRONG>Password:</STRONG> ",
	  "<FONT FACE=\"Courier\"><INPUT TYPE=PASSWORD NAME=password SIZE=15></FONT>\n",
	  "<INPUT TYPE=HIDDEN NAME=reviewone ",
	  "VALUE=\"Define View\">\n",
	  "<P><INPUT TYPE=SUBMIT VALUE=\"Review Accounts\"> ",
	  "</FORM></CENTER>\n";
	&Footer;
}

sub InitializePassword {
	&Header("WebAdverts","Enter an Administrative Password!");
	print "<P>Before you can do anything else, ",
	  "you'll need to set your administrative password. ",
	  "This will allow you to access the admin functions, ",
	  "create and edit accounts, review statistics, etc. ",
	  "Please enter your desired password below. ",
	  "(Enter it twice.)\n",
	  "<FORM METHOD=POST ACTION=$admin_cgi>\n",
	  "<INPUT TYPE=HIDDEN NAME=newpass VALUE=yes> ",
	  "<P><CENTER><INPUT TYPE=SUBMIT ",
	  "VALUE=\"Set Admin Password:\"> ",
	  "<FONT FACE=\"Courier\"><INPUT TYPE=PASSWORD NAME=passad SIZE=10> ",
	  "<INPUT TYPE=PASSWORD NAME=passad2 SIZE=10></FONT>\n",
	  "</CENTER></FORM>\n";
	&Footer;
}

sub ConfirmAdminPassword {
	local($which_admin) = @_;
	if ($INPUT{'password'}) {
		$newpassword = crypt($INPUT{'password'}, "aa");
	}
	else {
		&Header("WebAdverts Error!","No Password!");
		print "<P ALIGN=CENTER>You must ";
		print "enter a password!\n";
		&Footer;
	}
	open (PASSWORD, "<$adverts_dir/adpassword.txt");
	$password = <PASSWORD>;
	close (PASSWORD);
	chop ($password) if ($password =~ /\n$/);
	unless ($password && ($newpassword eq $password)) {
		if ($AllowUserEdit && $INPUT{'newuser'} && ($which_admin == 2)) {
			&Header("WebAdverts Error!","Name in Use!");
			print "<P ALIGN=CENTER>";
			print "The account name you entered ";
			print "is already in use!\n";
			&Footer;
		}
		else {
			&Header("WebAdverts Error!","Invalid Password!");
			print "<P ALIGN=CENTER>";
			print "The password you entered is incorrect!\n";
			&Footer;
		}
	}
	$cryptword = 1;
}

sub ConfirmUserPassword {
	unless ($INPUT{'password'}) {
		&Header("WebAdverts Error!","No Password!");
		print "<P ALIGN=CENTER>You must enter a password!\n";
		&Footer;
	}
	$INPUT{'advert'} =~ s/[^\w_-]//g;
	$INPUT{'advert'} =~ tr/A-Z/a-z/;
	if ($INPUT{'admincheck'}) {
		&ConfirmAdminPassword(2);
	}
	open (DISPLAY, "<$adverts_dir/$INPUT{'advert'}.txt");
	@lines = <DISPLAY>;
	close (DISPLAY);
	foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
	$pass = $lines[8];
	unless ($INPUT{'password'} eq $pass) {
		if ($INPUT{'groupstatus'}) {
			open (DISPLAY, "<$adverts_dir/$INPUT{'groupstatus'}.grp");
			@grpck = <DISPLAY>;
			close (DISPLAY);
			foreach $grpln (@grpck) { chop ($grpln) if ($grpln =~ /\n$/); }
		}
		unless ($grpck[0] && ($INPUT{'password'} eq $grpck[0])) {
			&ConfirmAdminPassword(2);
		}
	}
}

sub GetPassword {
	open (DISPLAY, "<$adverts_dir/$INPUT{'getpass'}.txt");
	@lines = <DISPLAY>;
	close (DISPLAY);
	foreach $line (@lines) {
		chop ($line) if ($line =~ /\n$/);
	}
	($pass,$email) = @lines[8,18];
	unless ($email) {
		&Header("WebAdverts Error!","No E-Mail Address!");
		print "<P ALIGN=CENTER>There is no e-mail address associated ";
		print "with the <STRONG>$INPUT{'getpass'}<STRONG> account!\n";
		&Footer;
	}
	&SendMail($email,"getpass");
	&Header("WebAdverts","Password Sent!");
	print "<P ALIGN=CENTER>The password for the <STRONG>$INPUT{'getpass'}</STRONG> ";
	print "account has been sent to <STRONG>$email</STRONG>!\n";
	&Footer;
}

sub defineview {
	&ConfirmAdminPassword(1);
	&Header("WebAdverts","WebAdverts Administrative Display");
	unless (-e "$adverts_dir/register.txt") {
		print "<P ALIGN=CENTER><STRONG>Unregistered copy.</STRONG> ";
		print "<A HREF=\"$admin_cgi?reginfo\">Click here</A> ";
		print "for registration info.<P><HR>\n";
	}
	print "<P ALIGN=CENTER><BIG><BIG><STRONG>Select Which Accounts ",
	  "You Wish to View:</STRONG></BIG></BIG>\n",
	  "<CENTER><FORM METHOD=POST ACTION=$admin_cgi>\n",
	  "<INPUT TYPE=HIDDEN NAME=password ",
	  "VALUE=\"$INPUT{'password'}\">\n";
	if ((-s "$adverts_dir/adnew.txt") || (-s "$adverts_dir/groups.txt")) {
		print "<P><STRONG>Pending Accounts (those awaiting ";
		print "administrative approval), Established Accounts,\n";
		print "<BR>and/or Defined Groups (&quot;sets&quot; ";
		print "of accounts):</STRONG>\n<BR>";
		if (-s "$adverts_dir/adnew.txt") {
			print "<INPUT TYPE=CHECKBOX NAME=whichtype ";
			print "VALUE=pending>Pending Accounts ";
		}
		print "<INPUT TYPE=CHECKBOX NAME=whichtype ";
		print "VALUE=established CHECKED>Established Accounts";
		if (-s "$adverts_dir/groups.txt") {
			print " <INPUT TYPE=CHECKBOX NAME=whichtype ";
			print "VALUE=groups>Defined Groups";
		}
		print "\n";
		print "<BR><SMALL><EM>(If no selection is made, ";
		print "only Established Accounts will be displayed.)</EM></SMALL>\n";
		print "<P><STRONG><EM>(If including Established Accounts, ";
		print "select which ones below.)</EM></STRONG>\n";
	}
	else {
		print "<INPUT TYPE=HIDDEN NAME=whichtype ";
		print "VALUE=established>\n";
	}
	print "<P><STRONG>Active Accounts, Expired Accounts,\n",
	  "<BR>and/or Disabled Accounts (those with weights ",
	  "temporarily set to 0):</STRONG>\n",
	  "<BR><INPUT TYPE=CHECKBOX NAME=whichtime ",
	  "VALUE=active CHECKED>Active Accounts ",
	  "<INPUT TYPE=CHECKBOX NAME=whichtime ",
	  "VALUE=expired>Expired Accounts ",
	  "<INPUT TYPE=CHECKBOX NAME=whichtime ",
	  "VALUE=disabled>Disabled Accounts\n",
	  "<BR><SMALL><EM>(If no selection is made, ",
	  "only Active Accounts will be displayed.)</EM></SMALL>\n";
	if (%nonssi_cgis) {
		print "<P><STRONG>Accounts Displaying in Zone(s):</STRONG>\n<BR>";
		foreach $setzone (sort (keys %nonssi_cgis)) {
			print "<INPUT TYPE=CHECKBOX NAME=whichzone ";
			print "VALUE=\"$setzone\" CHECKED>$setzone ";
		}
		print "\n";
		print "<BR><SMALL><EM>(If no selection is made, ";
		print "accounts from all zones will be displayed.)</EM></SMALL>\n";
	}
	print "<INPUT TYPE=HIDDEN NAME=reviewone ";
	print "VALUE=\"Review All Accounts\">\n";
	print "<P><INPUT TYPE=SUBMIT VALUE=\"Review Accounts\"> ";
	print "</FORM></CENTER>\n";
	&Footer;
}

sub reviewall {
	&ConfirmAdminPassword(1);
	&Header("WebAdverts","WebAdverts Administrative Display");
	unless (-e "$adverts_dir/register.txt") {
		print "<P ALIGN=CENTER><STRONG>";
		print "Unregistered copy.</STRONG> ";
		print "<A HREF=\"$admin_cgi?reginfo\">Click here</A> ";
		print "for registration info.<P><HR>\n";
	}
	unless ($INPUT{'whichtype'}) { $INPUT{'whichtype'} = "established"; }
	unless ($INPUT{'whichtime'}) { $INPUT{'whichtime'} = "active"; }
	if ($INPUT{'whichtype'} =~ /established/) {
		print "<P ALIGN=CENTER><BIG><BIG><STRONG>";
		print "The Following Accounts ";
		print "Have Been Established:</STRONG></BIG></BIG>\n";
		if ($AdminDisplaySetup) {
			print "<P ALIGN=CENTER>";
			print "(Accounts Included: ";
			print "$INPUT{'whichtime'})\n";
			if ($INPUT{'whichzone'}) {
				@whichzones = split(/\s+/,$INPUT{'whichzone'});
				print "<BR>(Zones Included: ";
				print "$INPUT{'whichzone'})\n";
			}
		}
		print "<P><CENTER><TABLE CELLPADDING=3>\n",
		  "<TR ALIGN=CENTER VALIGN=BOTTOM>",
		  "<TD><SMALL><FONT $fontspec><EM>Account</EM><BR><HR NOSHADE></FONT></SMALL></TD>",
		  "<TD><SMALL><FONT $fontspec><EM>Start</EM><BR><HR NOSHADE></FONT></SMALL></TD>",
		  "<TD><SMALL><FONT $fontspec><EM>End</EM><BR><HR NOSHADE></FONT></SMALL></TD>",
		  "<TD NOWRAP><SMALL><FONT $fontspec><EM>Zone(s)</EM><BR><HR NOSHADE></FONT></SMALL></TD>",
		  "<TD><SMALL><FONT $fontspec><EM>Wt.</EM><BR><HR NOSHADE></FONT></SMALL></TD>",
		  "<TD><SMALL><FONT $fontspec><EM>Exposures</EM><BR><HR NOSHADE></FONT></SMALL></TD>",
		  "<TD NOWRAP><SMALL><FONT $fontspec><EM>Exp./Day</EM><BR><HR NOSHADE></FONT></SMALL></TD>",
		  "<TD><SMALL><FONT $fontspec><EM>Clicks</EM><BR><HR NOSHADE></FONT></SMALL></TD>",
		  "<TD><SMALL><FONT $fontspec><EM>%</EM><BR><HR NOSHADE></FONT></SMALL></TD>",
		  "<TD><SMALL><FONT $fontspec><EM>Ratio</EM><BR><HR NOSHADE></FONT></SMALL></TD></TR>\n";
		open (COUNT, "<$adverts_dir/adcount.txt");
		@lines = <COUNT>;
		close (COUNT);
		if (@lines < 2) {
			print "</TABLE></CENTER>\n";
			print "<P ALIGN=CENTER>[ File Error: ";
			print "adcount.txt ]\n";
			&Footer;
		}
		open (LIST, "<$adverts_dir/adlist.txt");
		while (defined($list = <LIST>)) {
			push (@lines,$list);
		}
		close (LIST);
		foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
		$max = @lines - 1;
		$exposures = $lines[1];
		($exposures,$other) = split (/\|/, $exposures);
		$starttime = $lines[2];
		@advertisements = @lines[3..$max];
		@sortedadverts = sort (@advertisements);
		foreach $advertiser (@sortedadverts) {
			$expired = 0;
			$name = $advertiser;
			next if (length($advertiser) < 1);
			open (DISPLAY, "<$adverts_dir/$advertiser.txt");
			@lines = <DISPLAY>;
			close (DISPLAY);
			foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
			($max,$shown,$visits,$url,$image,$height,$width,
			  $alt,$pass,$text,$start,$weight,$zone,
			  $border,$target,$raw,$displayratio,$username,$email,
			  $displayzone,$clicksfrom) = @lines;
			unless ($max || $displayratio) {
				print "<TR ALIGN=CENTER>";
				print "<TD COLSPAN=10><SMALL><FONT $fontspec>";
				print "[ File Error: ";
				print "$advertiser.txt ]</FONT></SMALL></TD></TR>\n";
				next;
			}
			if ($INPUT{'whichzone'} && (length($zone)>2)) {
				$zoneok = 0;
				foreach $whichzones (@whichzones) {
					if ($zone =~ /$whichzones/) {
						$zoneok = 1;
					}
				}
				next unless ($zoneok);
			}
			($max,$maxtype) = split (/\|/, $max);
			unless ($maxtype) { $maxtype = "E"; }
			($text,$texttype) = split (/\|/, $text);
			unless ($texttype) { $texttype = "B"; }
			($displayratio,$displaycount) = split (/\|/, $displayratio);
			if (($maxtype eq "N") && ($displayratio > 0)) {
				$max = int($displaycount/$displayratio);
			}
			if (($maxtype eq "E") && ($displayratio > 0)) {
				$max = $max+int($displaycount/$displayratio);
			}
			if ($max < 1) { $max = "0"; }
			$runtime = 0;
			if ($start) {
				$runtime = $time - $start + 1;
			}
			$average = 0;
			if (($weight > 0) && ($runtime > 86400)) {
				&GetAverage;
			}
			$expirationstatus = "";
			if ($maxtype eq "D") {
				($sec,$min,$hour,$mday,$mon,$year,
				  $wday,$yday,$isdst) = localtime($max);
				$year += 1900;
				$expirationstatus .= "<TD NOWRAP><SMALL><FONT $fontspec>$mday $months[$mon] $year";
				unless ($max > $time) {
					$expired = 1 ;
					$expirationstatus .=
					  "<BR><EM>EXPIRED!</EM>";
				}
				$expirationstatus .= "</FONT></SMALL></TD>";
			}
			elsif (($maxtype eq "N") && ($max < 1)) {
				if ($displayratio > 1) {
					$expirationstatus .= "<TD NOWRAP><SMALL><FONT $fontspec>0 exposures<BR><EM>(non-expiring!)</EM></FONT></SMALL></TD>";
				}
				else {
					$expirationstatus .= "<TD NOWRAP><SMALL><FONT $fontspec><EM>(non-expiring!)</EM></FONT></SMALL></TD>";
				}
			}
			else {
				$expirationstatus .= "<TD NOWRAP><SMALL><FONT $fontspec>".&commas($max);
				if ($maxtype eq "C") {
					$expirationstatus .= " clicks";
					if (($average == 0) || ($shown == 0) || ($visits == 0)) {
						$expirationstatus .= "<BR><EM>(date unknown)</EM>";
					}
					elsif ($max > $visits) {
						$daystogo = (($max-$visits)/($average*($visits/$shown)));
						$calculatedend = $time+($daystogo*86400);
						($sec,$min,$hour,$mday,$mon,$year,
						  $wday,$yday,$isdst) = localtime($calculatedend);
						$year += 1900;
						$expirationstatus .= "<BR><EM>(~ $mday $months[$mon] $year)</EM>";
					}
					else {
						$expired = 1;
						$expirationstatus .=
						  "<BR><EM>EXPIRED!</EM>";
					}
				}
				else {
					$expirationstatus .= " exposures";
					if ($displayratio > 0) {
						$expirationstatus .= "<BR><EM>(non-expiring!)</EM>";
					}
					elsif ($average == 0) {
						$expirationstatus .= "<BR><EM>(date unknown)</EM>";
					}
					elsif ($max > $shown) {
						$daystogo = (($max-$shown)/$average);
						$calculatedend = $time+($daystogo*86400);
						($sec,$min,$hour,$mday,$mon,$year,
						  $wday,$yday,$isdst) = localtime($calculatedend);
						$year += 1900;
						$expirationstatus .= "<BR><EM>(~ $mday $months[$mon] $year)</EM>";
					}
					else {
						$expired = 1;
						$expirationstatus .=
						  "<BR><EM>EXPIRED!</EM>";
					}
				}
				$expirationstatus .= "</FONT></SMALL></TD>";
			}
			next if (($expired == 1) && ($INPUT{'whichtime'} !~ /expired/));
			next if (($expired == 0) && ($weight == 0)
			  && ($INPUT{'whichtime'} !~ /disabled/));
			next if (($expired == 0) && ($weight > 0)
			  && ($INPUT{'whichtime'} !~ /active/));
			if (($shown == 0) || ($visits == 0)) {
				$perc = "N/A";
				$ratio = "N/A";
			}
			else {
				$perc = ((100*($visits/$shown))+.05001);
				$ratio = (($shown/$visits)+.5001);
			}
			unless ($perc eq "N/A") {
				$perc =~ s/(\d+\.\d).*/$1/;
				$perc = $perc."%";
			}
			unless ($ratio eq "N/A") {
				$ratio =~ s/(\d+)\.\d.*/$1/;
				$ratio = $ratio.":1";
			}
			print "<TR ALIGN=CENTER>\n",
			  "<FORM METHOD=POST ACTION=$admin_cgi><TD><SMALL><FONT $fontspec>",
			  "<INPUT TYPE=HIDDEN NAME=password ",
			  "VALUE=\"$INPUT{'password'}\">",
			  "<INPUT TYPE=SUBMIT NAME=reviewone ",
			  "VALUE=\"$advertiser\">",
			  "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>",
			  "</FONT></SMALL></TD></FORM>\n";
			$runtime = 0;
			if ($start) {
				($sec,$min,$hour,$mday,$mon,$year,
				  $wday,$yday,$isdst) = localtime($start);
				$year += 1900;
				print "<TD NOWRAP><SMALL><FONT $fontspec>$mday $months[$mon] $year</FONT></SMALL></TD>";
			}
			else { print "<TD></TD>"; }
			print "$expirationstatus";
			print "<TD NOWRAP><SMALL><FONT $fontspec>$zone</FONT></SMALL></TD>";
			print "<TD><SMALL><FONT $fontspec>$weight</FONT></SMALL></TD>";
			print "<TD><SMALL><FONT $fontspec>",&commas($shown),"</FONT></SMALL></TD>";
			if ($expired || ($weight < 1)) {
				print "<TD><SMALL><FONT $fontspec>--</FONT></SMALL></TD>";
			}
			elsif ($average > 0) {
				print "<TD><SMALL><FONT $fontspec>",&commas($average),"</FONT></SMALL></TD>";
			}
			else {
				print "<TD><SMALL><FONT $fontspec>N/A</FONT></SMALL></TD>";
			}
			print "<TD><SMALL><FONT $fontspec>",&commas($visits),"</FONT></SMALL></TD>";
			print "<TD><SMALL><FONT $fontspec>$perc</FONT></SMALL></TD><TD><SMALL><FONT $fontspec>$ratio</FONT></SMALL></TD></TR>\n";
		}
		print "</TABLE></CENTER>\n";
		print "<P ALIGN=CENTER>";
		($sec,$min,$hour,$mday,$mon,$year,
		  $wday,$yday,$isdst) = localtime($time);
		if ($hour < 10) { $hour = "0".$hour; }
		if ($min < 10) { $min = "0".$min; }
		$year += 1900;
		print "(These figures are accurate as of ";
		print "$hour:$min on $mday $months[$mon] $year.";
		($sec,$min,$hour,$mday,$mon,$year,
		  $wday,$yday,$isdst) = localtime($starttime);
		if ($hour < 10) { $hour = "0".$hour; }
		if ($min < 10) { $min = "0".$min; }
		$year += 1900;
		print "<BR>Since $hour:$min on $mday $months[$mon] $year, ";
		print "there have been a total of <STRONG>",&commas($exposures);
		print "</STRONG> advert exposures";
		$time = $time - $starttime + 1;
		if ($time > 86400) {
			$average = int(($exposures/($time/86400))+.5);
			print ",<BR>for an average of <STRONG>",&commas($average);
			print "</STRONG> exposures per day";
		}
		print ".)\n<P><HR>";
	}
	if ((-s "$adverts_dir/adnew.txt") && ($INPUT{'whichtype'} =~ /pending/)) {
		undef @newlines;
		open (COUNT, "<$adverts_dir/adnew.txt");
		@newlines = <COUNT>;
		close (COUNT);
	}
	if (@newlines > 0) {
		print "<P ALIGN=CENTER><BIG><BIG><STRONG>";
		print "The Following Accounts Await ";
		print "Administrative Approval:";
		print "</STRONG></BIG></BIG><CENTER>\n";
		@sortednewlines = sort (@newlines);
		foreach $newad (@sortednewlines) {
			chop ($newad) if ($newad =~ /\n$/);
			next if (length($newad) < 1);
			open (DISPLAY, "<$adverts_dir/$newad.txt");
			@lines = <DISPLAY>;
			close (DISPLAY);
			foreach $line (@lines) {
				chop ($line) if ($line =~ /\n$/);
			}
			($max,$shown,$visits,$url,$image,$height,$width,
			  $alt,$pass,$text,$start,$weight,$zone,
			  $border,$target,$raw,$displayratio,$username,$email,
			  $displayzone,$clicksfrom) = @lines;
			print "<P><FORM METHOD=POST ACTION=$admin_cgi>",
			  "<INPUT TYPE=HIDDEN NAME=password ",
			  "VALUE=\"$INPUT{'password'}\">",
			  "<INPUT TYPE=SUBMIT NAME=reviewone ",
			  "VALUE=\"$newad\">",
			  "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>",
			  "</FORM>\n";
		}
		print "</CENTER>\n<P><HR>";
	}
	if ((-s "$adverts_dir/groups.txt") && ($INPUT{'whichtype'} =~ /groups/)) {
		undef @grouplines;
		open (COUNT, "<$adverts_dir/groups.txt");
		@grouplines = <COUNT>;
		close (COUNT);
	}
	if (@grouplines > 0) {
		print "<P ALIGN=CENTER><BIG><BIG><STRONG>";
		print "The Following Groups Have Been Defined:";
		print "</STRONG></BIG></BIG>\n";
		print "<P><CENTER><TABLE CELLPADDING=3>\n";
		@sortedgroups = sort (@grouplines);
		foreach $group (@sortedgroups) {
			chop ($group) if ($group =~ /\n$/);
			next if (length($group) < 1);
			open (DISPLAY, "<$adverts_dir/$group.grp");
			@members = <DISPLAY>;
			close (DISPLAY);
			$grppassword = $members[0];
			print "<TR ALIGN=CENTER>",
			  "<FORM METHOD=POST ",
			  "ACTION=$admin_cgi><TD><SMALL><FONT $fontspec>",
			  "<INPUT TYPE=HIDDEN NAME=password ",
			  "VALUE=$INPUT{'password'}>\n",
			  "<INPUT TYPE=HIDDEN NAME=editgroup ",
			  "VALUE=\"$group\">\n",
			  "<INPUT TYPE=SUBMIT NAME=groupedit ",
			  "VALUE=\"$group\">",
			  "</FONT></SMALL></TD></FORM>\n",
			  "<TD><SMALL><FONT $fontspec>";
			foreach $member (@members) {
				unless ($member eq $grppassword) {
					chop ($member)
					  if ($member =~ /\n$/);
					print " $member";
				}
			}
			print "</FONT></SMALL></TD></TR>\n";
		}
		print "</TABLE></CENTER>\n<P><HR>";
	}
	print "<FORM METHOD=POST ACTION=$admin_cgi>\n",
	  "<CENTER><P><BIG><BIG><STRONG>The Following Options ",
	  "Are Available:</STRONG></BIG></BIG>\n",
	  "<INPUT TYPE=HIDDEN NAME=password ",
	  "VALUE=$INPUT{'password'}>\n",
	  "<P><STRONG>Add/Edit/Delete Account:</STRONG> ",
	  "<FONT FACE=\"Courier\"><INPUT TYPE=TEXT NAME=editad SIZE=25 ",
	  "VALUE=\"(enter account name)\"></FONT> ",
	  "<INPUT TYPE=SUBMIT NAME=edit ",
	  "VALUE=\"Edit Account\">\n",
	  "<P><STRONG>Add/Edit/Delete Group:</STRONG> ",
	  "<FONT FACE=\"Courier\"><INPUT TYPE=TEXT NAME=editgroup SIZE=25 ",
	  "VALUE=\"(enter group name)\"></FONT> ",
	  "<INPUT TYPE=SUBMIT NAME=groupedit ",
	  "VALUE=\"Edit Group\">\n",
	  "<P><STRONG>Change Admin Password:</STRONG> ",
	  "<FONT FACE=\"Courier\"><INPUT TYPE=PASSWORD NAME=passad SIZE=10> ",
	  "<INPUT TYPE=PASSWORD NAME=passad2 SIZE=10></FONT> ",
	  "<INPUT TYPE=SUBMIT NAME=newpass ",
	  "VALUE=\"Change Password\">\n";
	if ($LogIP) {
		print "<P><INPUT TYPE=SUBMIT NAME=masteriplog ",
		  "VALUE=\"View Master IP Access Log\">\n";
	}
	if ($LogAdminAccesses) {
		print "<P><INPUT TYPE=SUBMIT NAME=adminlog ",
		  "VALUE=\"View Admin Access Log\">\n";
	}
	print "<P><INPUT TYPE=SUBMIT NAME=resetcount ",
	  "VALUE=\"Reset Overall Total Exposures Count\">\n",
	  "<P><INPUT TYPE=SUBMIT NAME=listemail ",
	  "VALUE=\"List All Account Holder E-Mails\">\n",
	  "</CENTER></FORM>\n";
	&LinkBack;
	&Footer;
}

sub ListEmail {
	&ConfirmAdminPassword(1);
	open (LIST, "<$adverts_dir/adlist.txt");
	@advertlist = <LIST>;
	close (LIST);
	foreach $advertiser (@advertlist) {
		chop ($advertiser) if ($advertiser =~ /\n$/);
		open (DISPLAY, "<$adverts_dir/$advertiser.txt");
		@lines = <DISPLAY>;
		close (DISPLAY);
		foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
		unless ($lines[18]) { next; }
		push (@emails,"&quot;$lines[17]&quot; &lt;<A HREF=\"mailto:$lines[18]\">$lines[18]</A>&gt;");

	}
	@sortedemails = sort (@emails);
	&Header("WebAdverts","WebAdverts Account Holder E-Mails");
	print "<P ALIGN=CENTER><BIG><BIG><STRONG>";
	print "Account Holder E-Mail Addresses:";
	print "</STRONG></BIG></BIG>\n";
	print "<P>";
	foreach $email (@sortedemails) {
		if ($email eq $lastemail) { next; }
		if ($lastemail) { print ", "; }
		print "$email";
		$lastemail = $email;
	}
	print "\n";
	&LinkBack;
	&Footer;
}

sub reviewgroup {
	$groupstatus = "$INPUT{'reviewone'}";
	unless (-s "$adverts_dir/$INPUT{'reviewone'}.grp") {
		if ($AllowUserEdit && $INPUT{'newuser'}) {
			&UserEdit;
		}
		&Header("WebAdverts Error!","Invalid Name!");
		print "<P ALIGN=CENTER>There is no ";
		print "account or group on the list with the name ";
		print "<STRONG>&quot;$INPUT{'reviewone'}&quot;</STRONG>!\n";
		print "<P ALIGN=CENTER>(Note that all names ";
		print "<EM>are</EM> case sensitive!)\n";
		&Footer;
	}
	open (DISPLAY, "<$adverts_dir/$INPUT{'reviewone'}.grp");
	@adverts = <DISPLAY>;
	close (DISPLAY);
	foreach $line (@adverts) { chop ($line) if ($line =~ /\n$/); }
	unless ($cryptword) {
		unless ($INPUT{'password'} eq $adverts[0]) {
			&ConfirmAdminPassword(2);
		}
	}
	&Header("WebAdverts","WebAdverts Administrative Display");
	print "<P ALIGN=CENTER><BIG><STRONG>(Accounts in the ";
	print "<EM>$INPUT{'reviewone'}</EM> Group)</STRONG></BIG>\n";
	foreach $advert (@adverts) {
		$name = $advert;
		next unless (-s "$adverts_dir/$advert.txt");
		open (DISPLAY, "<$adverts_dir/$advert.txt");
		@lines = <DISPLAY>;
		close (DISPLAY);
		foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
		($max,$shown,$visits,$url,$image,$height,$width,
		  $alt,$pass,$text,$start,$weight,$zone,
		  $border,$target,$raw,$displayratio,$username,$email,
		  $displayzone,$clicksfrom) = @lines;
		($max,$maxtype) = split (/\|/, $max);
		unless ($maxtype) { $maxtype = "E"; }
		($text,$texttype) = split (/\|/, $text);
		unless ($texttype) { $texttype = "B"; }
		($displayratio,$displaycount) = split (/\|/, $displayratio);
		if (($maxtype eq "E") && ($displayratio > 0)) {
			$max = $max+int($displaycount/$displayratio);
		}
		$TotalShown += $shown;
		$TotalVisits += $visits;
		print "<P><HR>\n";
		&reviewadvert;
	}
	print "<P><HR><P ALIGN=CENTER><BIG><BIG><STRONG>Master Overview:",
	  "</STRONG></BIG></BIG>\n",
	  "<P><CENTER><TABLE CELLPADDING=3>\n",
	  "<TR ALIGN=CENTER VALIGN=BOTTOM>",
	  "<TD><SMALL><FONT $fontspec><EM>Exposures</EM><BR><HR NOSHADE></FONT></SMALL></TD>",
	  "<TD><SMALL><FONT $fontspec><EM>Clicks</EM><BR><HR NOSHADE></FONT></SMALL></TD>",
	  "<TD><SMALL><FONT $fontspec><EM>%</EM><BR><HR NOSHADE></FONT></SMALL></TD>",
	  "<TD><SMALL><FONT $fontspec><EM>Ratio</EM><BR><HR NOSHADE></FONT></SMALL></TD></TR>\n";
	if (($TotalShown == 0) || ($TotalVisits == 0)) {
		$perc = "N/A";
		$ratio = "N/A";
	}
	else {
		$perc = ((100*($TotalVisits/$TotalShown))+.05001);
		$ratio = (($TotalShown/$TotalVisits)+.5001);
	}
	unless ($perc eq "N/A") {
		$perc =~ s/(\d+\.\d).*/$1/;
		$perc = $perc."%";
	}
	unless ($ratio eq "N/A") {
		$ratio =~ s/(\d+)\.\d.*/$1/;
		$ratio = $ratio.":1";
	}
	print "<TR ALIGN=CENTER>";
	print "<TD><SMALL><FONT $fontspec>",&commas($TotalShown),"</FONT></SMALL></TD>";
	print "<TD><SMALL><FONT $fontspec>",&commas($TotalVisits),"</FONT></SMALL></TD>";
	print "<TD><SMALL><FONT $fontspec>$perc</FONT></SMALL></TD><TD><SMALL><FONT $fontspec>$ratio</FONT></SMALL></TD></TR>\n";
	print "</TABLE></CENTER>\n";
	&Footer("Group: $INPUT{'reviewone'}");
}

sub reviewone {
	unless ($INPUT{'password'}) {
		&Header("WebAdverts Error!","No Password!");
		print "<P ALIGN=CENTER>You must enter a password!\n";
		&Footer;
	}
	$INPUT{'reviewone'} =~ s/[^\w_-]//g;
	$INPUT{'reviewone'} =~ tr/A-Z/a-z/;
	if ($INPUT{'admincheck'}) {
		&ConfirmAdminPassword(2);
	}
	unless (-s "$adverts_dir/$INPUT{'reviewone'}.txt") {
		&reviewgroup;
	}
	$name = $INPUT{'reviewone'};
	open (DISPLAY, "<$adverts_dir/$INPUT{'reviewone'}.txt");
	@lines = <DISPLAY>;
	close (DISPLAY);
	foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
	($max,$shown,$visits,$url,$image,$height,$width,
	  $alt,$pass,$text,$start,$weight,$zone,
	  $border,$target,$raw,$displayratio,$username,$email,
	  $displayzone,$clicksfrom) = @lines;
	($max,$maxtype) = split (/\|/, $max);
	unless ($maxtype) { $maxtype = "E"; }
	($text,$texttype) = split (/\|/, $text);
	unless ($texttype) { $texttype = "B"; }
	($displayratio,$displaycount) = split (/\|/, $displayratio);
	if (($maxtype eq "N") && ($displayratio > 0)) {
		$max = int($displaycount/$displayratio);
	}
	if (($maxtype eq "E") && ($displayratio > 0)) {
		$max = $max+int($displaycount/$displayratio);
	}
	if ($max < 1) { $max = "0"; }
	unless ($cryptword) {
		unless ($INPUT{'password'} eq $pass) {
			&ConfirmAdminPassword(2);
		}
	}
	&Header("WebAdverts","WebAdverts Administrative Display");
	&reviewadvert;
	if ($cryptword) {
		&LinkBack;
	}
	&Footer("Account: $INPUT{'reviewone'}");
}

sub reviewadvert {
	$expired = 0;
	print "<CENTER><P><BIG><BIG><STRONG>Current Status of the ";
	print "<EM>$name</EM> Account:</STRONG></BIG></BIG>\n";
	open (COUNT, "$adverts_dir/adnew.txt");
	@lines = <COUNT>;
	close (COUNT);
	foreach $line (@lines) {
		chop ($line) if ($line =~ /\n$/);
		if ($line eq $name) {
			print "<P>(This account is awaiting administrative approval.)";
			last;
		}
	}
	print "</CENTER>\n";
	print "<P><CENTER><TABLE CELLPADDING=3>\n";
	print "<TR ALIGN=CENTER VALIGN=BOTTOM>";
	print "<TD><SMALL><FONT $fontspec><EM>Start</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
	if ($displayratio) {
		print "<TD NOWRAP><SMALL><FONT $fontspec><EM>Banners Shown<BR>";
		print "on Your Site</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
		print "<TD NOWRAP><SMALL><FONT $fontspec><EM>Clicks From<BR>";
		print "Your Site</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
		print "<TD><SMALL><FONT $fontspec><EM>%</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
		print "<TD><SMALL><FONT $fontspec><EM>Ratio</EM><BR><HR NOSHADE></FONT></SMALL></TD></TR>\n";
		print "<TR ALIGN=CENTER>";
		if ($start) {
			($sec,$min,$hour,$mday,$mon,$year,
			  $wday,$yday,$isdst) = localtime($start);
			$year += 1900;
			print "<TD NOWRAP><SMALL><FONT $fontspec>$mday $months[$mon] $year</FONT></SMALL></TD>";
			$runtime = $time - $start + 1;
		}
		else { print "<TD></TD>"; }
		if (($displaycount == 0) || ($clicksfrom == 0)) {
			$foreignperc = "N/A";
			$foreignratio = "N/A";
		}
		else {
			$foreignperc = ((100*($clicksfrom/$displaycount))+.05001);
			$foreignratio = (($displaycount/$clicksfrom)+.5001);
		}
		unless ($foreignperc eq "N/A") {
			$foreignperc =~ s/(\d+\.\d).*/$1/;
			$foreignperc = $foreignperc."%";
		}
		unless ($foreignratio eq "N/A") {
			$foreignratio =~ s/(\d+)\.\d.*/$1/;
			$foreignratio = $foreignratio.":1";
		}
		print "<TD><SMALL><FONT $fontspec>",&commas($displaycount),"</FONT></SMALL></TD>";
		print "<TD><SMALL><FONT $fontspec>",&commas($clicksfrom),"</FONT></SMALL></TD>";
		print "<TD><SMALL><FONT $fontspec>$foreignperc</FONT></SMALL></TD>";
		print "<TD><SMALL><FONT $fontspec>$foreignratio</FONT></SMALL></TD></TR>\n";
		print "</TABLE>\n";
		print "<P><TABLE CELLPADDING=3>\n";
		print "<TR ALIGN=CENTER VALIGN=BOTTOM>";
	}
	else {
		print "<TD><SMALL><FONT $fontspec><EM>End</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
	}
	if ($image || $raw || $shown || $visits) {
		print "<TD NOWRAP><SMALL><FONT $fontspec><EM>Your Banner's<BR>";
		print "Exposures</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
		print "<TD><SMALL><FONT $fontspec><EM>Exp./Day</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
		print "<TD NOWRAP><SMALL><FONT $fontspec><EM>Clicks On<BR>";
		print "Your Banner</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
		print "<TD><SMALL><FONT $fontspec><EM>%</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
		print "<TD><SMALL><FONT $fontspec><EM>Ratio</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
	}
	print "</TR>\n";
	if (($shown == 0) || ($visits == 0)) {
		$perc = "N/A";
		$ratio = "N/A";
	}
	else {
		$perc = ((100*($visits/$shown))+.05001);
		$ratio = (($shown/$visits)+.5001);
	}
	unless ($perc eq "N/A") {
		$perc =~ s/(\d+\.\d).*/$1/;
		$perc = $perc."%";
	}
	unless ($ratio eq "N/A") {
		$ratio =~ s/(\d+)\.\d.*/$1/;
		$ratio = $ratio.":1";
	}
	print "<TR ALIGN=CENTER>";
	$runtime = 0;
	if ($start) {
		($sec,$min,$hour,$mday,$mon,$year,
		  $wday,$yday,$isdst) = localtime($start);
		$year += 1900;
		unless ($displayratio) {
			print "<TD NOWRAP><SMALL><FONT $fontspec>$mday $months[$mon] $year</FONT></SMALL></TD>";
		}
		$runtime = $time - $start + 1;
	}
	else {
		unless ($displayratio) {
			print "<TD></TD>";
		}
	}
	$average = 0;
	if (($weight > 0) && ($runtime > 86400)) {
		&GetAverage;
	}
	unless ($displayratio) {
		if ($maxtype eq "D") {
			($sec,$min,$hour,$mday,$mon,$year,
			  $wday,$yday,$isdst) = localtime($max);
			$year += 1900;
			print "<TD NOWRAP><SMALL><FONT $fontspec>$mday $months[$mon] $year";
			unless ($max > $time) {
				$expired = 1;
				print "<BR><EM>EXPIRED!</EM>";
			}
			print "</FONT></SMALL></TD>";
		}
		elsif (($maxtype eq "N") && ($max < 1)) {
			if ($displayratio > 1) {
				print "<TD NOWRAP><SMALL><FONT $fontspec>0 exposures<BR><EM>(non-expiring!)</EM></FONT></SMALL></TD>";
			}
			else {
				print "<TD NOWRAP><SMALL><FONT $fontspec><EM>(non-expiring!)</EM></FONT></SMALL></TD>";
			}
		}
		else {
			print "<TD NOWRAP><SMALL><FONT $fontspec>",&commas($max);
			if ($maxtype eq "C") {
				print " clicks";
				if (($average == 0) || ($shown == 0) || ($visits == 0)) {
					print "<BR><EM>(date unknown)</EM>";
				}
				elsif ($max > $visits) {
					$daystogo = (($max-$visits)/($average*($visits/$shown)));
					$calculatedend = $time+($daystogo*86400);
					($sec,$min,$hour,$mday,$mon,$year,
					  $wday,$yday,$isdst) = localtime($calculatedend);
					$year += 1900;
					print "<BR><EM>(~ $mday $months[$mon] $year)</EM>";
				}
				else {
					$expired = 1;
					print "<BR><EM>EXPIRED!</EM>";
				}
			}
			else {
				print " exposures";
				if ($displayratio > 0) {
					print "<BR><EM>(non-expiring!)</EM>";
				}
				elsif ($average == 0) {
					print "<BR><EM>(date unknown)</EM>";
				}
				elsif ($max > $shown) {
					$daystogo = (($max-$shown)/$average);
					$calculatedend = $time+($daystogo*86400);
					($sec,$min,$hour,$mday,$mon,$year,
					  $wday,$yday,$isdst) = localtime($calculatedend);
					$year += 1900;
					print "<BR><EM>(~ $mday $months[$mon] $year)</EM>";
				}
				else {
					$expired = 1;
					print "<BR><EM>EXPIRED!</EM>";
				}
			}
			print "</FONT></SMALL></TD>";
		}
	}
	if ($image || $raw || $shown || $visits) {
		print "<TD><SMALL><FONT $fontspec>",&commas($shown),"</FONT></SMALL></TD>";
		if ($expired || ($weight < 1)) {
			print "<TD><SMALL><FONT $fontspec>--</FONT></SMALL></TD>";
		}
		elsif ($average > 0) {
			print "<TD><SMALL><FONT $fontspec>",&commas($average),"</FONT></SMALL></TD>";
		}
		else {
			print "<TD><SMALL><FONT $fontspec>N/A</FONT></SMALL></TD>";
		}
		print "<TD><SMALL><FONT $fontspec>",&commas($visits),"</FONT></SMALL></TD>";
		print "<TD><SMALL><FONT $fontspec>$perc</FONT></SMALL></TD><TD><SMALL><FONT $fontspec>$ratio</FONT></SMALL></TD>";
	}
	print "</TR></TABLE></CENTER>\n";
	unless ($image || $raw) {
		print "<P>Your account currently has no assigned banner.\n";
	}
	if ($displayratio || $displaycount) {
		if ($displaycount<1) { $displaycount = "0"; }
		print "<P>To date, you have displayed <STRONG>";
		print &commas($displaycount),"</STRONG> banners ";
		print "on your site";
		if ($displayratio > 0) {
			$earnings = int($displaycount/$displayratio);
			print ", earning <STRONG>";
			print &commas($earnings),"</STRONG> exposures ";
			print "for your own banner on other sites. ";
			print "(You earn an exposure for each ";
			print "<STRONG>$displayratio</STRONG> display";
			if ($displayratio > 1) { print "s"; }
			print ".)";
		}
		else {
			print ".";
		}
		if ($max > $earnings) {
			print " Your account has been assigned an additional <STRONG>";
			print &commas($max-$earnings);
			print "</STRONG> &quot;bonus&quot; exposures, as well.";
		}
		print "\n<P>The HTML code below should be placed on your site ";
		print "where you want banners to appear.\n";
		print "<P><BLOCKQUOTE><STRONG>";
		if ($IFRAMEexchange) { $DefaultBorder = 0; }
		$HTMLCode = "";
		if ($ExchangeName) {
			$HTMLCode = "&lt;!-- Begin $ExchangeName Code --&gt;\n<BR>";
		}
		$HTMLCode .= "&lt;P&gt;&lt;CENTER&gt;\n";
		if ($ExchangeLogo
		  && (($ExchangeLogoPosition =~ /^t/i)
		  || ($ExchangeLogoPosition =~ /^l/i)
		  || ($ExchangeLogoPosition =~ /^1/i)
		  || !($ExchangeLogoPosition))) {
			$HTMLCode .= "<BR>";
			if ($ExchangeURL) {
				$HTMLCode .= "&lt;A HREF=&quot;$ExchangeURL&quot;";
				$HTMLCode .= " $DefaultLinkAttribute&gt;";
			}
			$HTMLCode .= "&lt;IMG SRC=&quot;$ExchangeLogo&quot;";
			if ($ExchangeLogoHeight && $ExchangeLogoWidth) {
				$HTMLCode .= " WIDTH=$ExchangeLogoWidth";
				$HTMLCode .= " HEIGHT=$ExchangeLogoHeight";
			}
			if ($ExchangeName) {
				$HTMLCode .= " ALT=&quot;$ExchangeName&quot;";
			}
			$HTMLCode .= " BORDER=$DefaultBorder&gt;";
			if ($ExchangeURL) {
				$HTMLCode .= "&lt;/A&gt;";
			}
			if ($ExchangeLogoPosition =~ /^t/i) {
				$HTMLCode .= "&lt;BR&gt;";
			}
			$HTMLCode .= "\n";
		}
		if (%nonssi_cgis) {
			foreach $setzone (keys %nonssi_cgis) {
				if ($displayzone eq $setzone) {
					$nonssi_cgi = $nonssi_cgis{$setzone};
					last;
				}
			}
		}
		if ($IFRAMEexchange) {
			$HTMLCode .= "<BR>&lt;IFRAME SRC=&quot;$nonssi_cgi?";
			$HTMLCode .= "iframe;member=$name&quot;";
			$HTMLCode .= " MARGINWIDTH=0 MARGINHEIGHT=0 HSPACE=0 VSPACE=0";
			$HTMLCode .= " FRAMEBORDER=0 SCROLLING=NO";
			if ($ExchangeBannerHeight && $ExchangeBannerWidth) {
				$HTMLCode .= " WIDTH=$ExchangeBannerWidth";
				$HTMLCode .= " HEIGHT=$ExchangeBannerHeight";
			}
			$HTMLCode .= "&gt;\n";
		}
		if ($JavaScriptExchange) {
			$HTMLCode .= "<BR>&lt;SCRIPT LANGUAGE=&quot;JavaScript&quot;&gt;&lt;!--\n";
			$HTMLCode .= "<BR>random = parseInt(Math.random()*1000)\n";
			$HTMLCode .= "<BR>banner = '&lt;A HREF=&quot;$nonssi_cgi?member=$name;banner=NonSSI;'\n";
			$HTMLCode .= "<BR>banner += 'page=' + random + '&quot; $DefaultLinkAttribute&gt;';\n";
			$HTMLCode .= "<BR>banner += '&lt;IMG SRC=&quot;$nonssi_cgi?member=$name;'\n";
			$HTMLCode .= "<BR>banner += 'page=' + random + '&quot;";
			if ($ExchangeBannerHeight && $ExchangeBannerWidth) {
				$HTMLCode .= " WIDTH=$ExchangeBannerWidth";
				$HTMLCode .= " HEIGHT=$ExchangeBannerHeight";
			}
			$HTMLCode .= "'\n<BR>banner += ' ";
			if ($ExchangeName) {
				$HTMLCode .= "ALT=&quot;$ExchangeName&quot; ";
			}
			$HTMLCode .= "BORDER=$DefaultBorder&gt;&lt;/A&gt;'\n";
			$HTMLCode .= "<BR>document.write(banner)\n<BR>// -->\n<BR>&lt;/SCRIPT&gt;\n"; 
		}
		else {
			$HTMLCode .= "<BR>&lt;A HREF=&quot;$nonssi_cgi?";
			$HTMLCode .= "member=$name;banner=NonSSI;page=01&quot;";
			$HTMLCode .= " $DefaultLinkAttribute&gt;";
			$HTMLCode .= "&lt;IMG SRC=&quot;$nonssi_cgi?";
			$HTMLCode .= "member=$name;page=01&quot;";
			if ($ExchangeBannerHeight && $ExchangeBannerWidth) {
				$HTMLCode .= " WIDTH=$ExchangeBannerWidth";
				$HTMLCode .= " HEIGHT=$ExchangeBannerHeight";
			}
			if ($ExchangeName) {
				$HTMLCode .= " ALT=&quot;$ExchangeName&quot;";
			}
			$HTMLCode .= " BORDER=$DefaultBorder&gt;&lt;/A&gt;\n";
		}
		if ($IFRAMEexchange) {
			$HTMLCode .= "<BR>&lt;/IFRAME&gt;\n";
		}
		if ($ExchangeLogo
		  && (($ExchangeLogoPosition =~ /^b/i)
		  || ($ExchangeLogoPosition =~ /^r/i))) {
			$HTMLCode .= "<BR>";
			if ($ExchangeLogoPosition =~ /^b/i) {
				$HTMLCode .= "&lt;BR&gt;";
			}
			if ($ExchangeURL) {
				$HTMLCode .= "&lt;A HREF=&quot;$ExchangeURL&quot;";
				$HTMLCode .= " $DefaultLinkAttribute&gt;";
			}
			$HTMLCode .= "&lt;IMG SRC=&quot;$ExchangeLogo&quot;";
			if ($ExchangeLogoHeight && $ExchangeLogoWidth) {
				$HTMLCode .= " WIDTH=$ExchangeLogoWidth";
				$HTMLCode .= " HEIGHT=$ExchangeLogoHeight";
			}
			if ($ExchangeName) {
				$HTMLCode .= " ALT=&quot;$ExchangeName&quot;";
			}
			$HTMLCode .= " BORDER=$DefaultBorder&gt;";
			if ($ExchangeURL) {
				$HTMLCode .= "&lt;/A&gt;";
			}
			$HTMLCode .= "\n";
		}
		if ($ExchangeName && !($ExchangeLogo)) {
			$HTMLCode .= "<BR>&lt;BR&gt;&lt;SMALL&gt;";
			if ($ExchangeURL) {
				$HTMLCode .= "&lt;A HREF=&quot;$ExchangeURL&quot;";
				$HTMLCode .= " $DefaultLinkAttribute&gt;";
			}
			$HTMLCode .= "$ExchangeName";
			if ($ExchangeURL) {
				$HTMLCode .= "&lt;/A&gt;";
			}
			$HTMLCode .= "&lt;/SMALL&gt;\n";
		}
		$HTMLCode .= "<BR>&lt;/CENTER&gt;\n";
		if ($ExchangeName) {
			$HTMLCode .= "<BR>&lt;!-- End $ExchangeName Code --&gt;\n";
		}
		print "$HTMLCode</STRONG></BLOCKQUOTE>\n";
		unless ($JavaScriptExchange) {
			print "<P>If you want banners to appear on more than one page ",
			  "(or more than once on a single page), ",
			  "simply use a unique &quot;page=&quot; number for each banner ",
			  "call. This will ensure that new banners are loaded (and that new ",
			  "displays are credited to you) on each of your pages. ",
			  "(Note that there are two &quot;page=&quot; designations in the ",
			  "call, and that they must match!)\n";
		}
	}
	print "<CENTER>";
	if (($AllowUserEdit || $cryptword) && !($groupstatus)) {
		print "<P><FORM METHOD=POST ACTION=$admin_cgi>\n";
		print "<INPUT TYPE=HIDDEN NAME=password ";
		print "VALUE=$INPUT{'password'}>\n";
		print "<INPUT TYPE=HIDDEN NAME=reviewone ";
		print "VALUE=$name>\n";
		if ($cryptword) {
			print "<INPUT TYPE=SUBMIT NAME=edit ";
		}
		else {
			print "<INPUT TYPE=SUBMIT NAME=UserEdit ";
		}
		print "VALUE=\"Edit Account\">";
		print "</FORM>\n";
	}
	print "<P><TABLE><TR ALIGN=CENTER>\n";
	print "<FORM METHOD=POST ACTION=$admin_cgi><TD><SMALL><FONT $fontspec>\n";
	print "<INPUT TYPE=HIDDEN NAME=password ";
	print "VALUE=$INPUT{'password'}>\n";
	if ($groupstatus) {
		print "<INPUT TYPE=HIDDEN NAME=groupstatus ";
		print "VALUE=\"$groupstatus\">\n";
	}
	print "<INPUT TYPE=HIDDEN NAME=advert VALUE=$name>\n";
	if ($cryptword) {
		print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
	}
	print "<INPUT TYPE=SUBMIT NAME=dailystats ";
	print "VALUE=\"View Daily Stats\">";
	print "</FONT></SMALL></TD></FORM>\n";
	print "<FORM METHOD=POST ACTION=$admin_cgi><TD><SMALL><FONT $fontspec>\n";
	print "<INPUT TYPE=HIDDEN NAME=password ";
	print "VALUE=$INPUT{'password'}>\n";
	if ($groupstatus) {
		print "<INPUT TYPE=HIDDEN NAME=groupstatus ";
		print "VALUE=\"$groupstatus\">\n";
	}
	print "<INPUT TYPE=HIDDEN NAME=advert VALUE=$name>\n";
	if ($cryptword) {
		print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
	}
	print "<INPUT TYPE=SUBMIT NAME=monthlystats ";
	print "VALUE=\"View Monthly Stats\">";
	print "</FONT></SMALL></TD></FORM>\n";
	if ($LogIP) {
		print "<FORM METHOD=POST ";
		print "ACTION=$admin_cgi><TD><SMALL><FONT $fontspec>\n";
		print "<INPUT TYPE=HIDDEN NAME=password ";
		print "VALUE=$INPUT{'password'}>\n";
		if ($groupstatus) {
			print "<INPUT TYPE=HIDDEN NAME=groupstatus ";
			print "VALUE=\"$groupstatus\">\n";
		}
		print "<INPUT TYPE=HIDDEN NAME=advert VALUE=$name>\n";
		if ($cryptword) {
			print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
		}
		print "<INPUT TYPE=SUBMIT NAME=iplog ";
		print "VALUE=\"View IP Address Log\">";
		print "</FONT></SMALL></TD></FORM>\n";
	}
	print "</TR></TABLE></CENTER>\n";
	if ($email && $INPUT{'welcomeletter'}) {
		open (WELCOME, "<$adverts_dir/welcome.txt");
		$body = "";
		while (defined($line = <WELCOME>)) {
			$body .= $line;
		}
		close (WELCOME);
		$HTMLCode =~ s/<BR>//g;
		$HTMLCode =~ s/&lt;/</g;
		$HTMLCode =~ s/&gt;/>/g;
		$HTMLCode =~ s/&quot;/"/g;
		$body =~ s/<--UserID-->/$name/g;
		$body =~ s/<--Password-->/$pass/g;
		$body =~ s/<--HTMLCode-->/$HTMLCode/g;
		&SendMail($email,"welcome");
	}
	&ShowAdvert;
}

sub GetAverage {
	open (DISPLAY, "<$adverts_dir/$name.log");
	@lines = <DISPLAY>;
	close (DISPLAY);
	@reverselines = reverse (@lines);
	$avexposures = 0;
	$linecount = 0;
	foreach $line (@reverselines) {
		next if (length($line)<10);
		($acc,$type) = ($line =~
		  /^(\d\d\d\d\d\d\d\d\d\d) \d\d \d\d \d\d\d\d (\w)$/);
		next unless ($type eq "E");
		$linecount++;
		next if ($linecount < 2);
		last if ($linecount > 8);
		$avexposures += int($acc);
	}
	unless ($linecount > 8) {
		$avexposures -= int($acc);
	}
	if (($avexposures < 1) || ($linecount < 3)) {
		return;
	}
	$average = int(($avexposures/($linecount-2))+.5);
}

sub dailystats {
	&ConfirmUserPassword;
	open (DISPLAY, "<$adverts_dir/$INPUT{'advert'}.log") || &Error_NoStats;
	@lines = <DISPLAY>;
	close (DISPLAY);
	foreach $line (@lines) {
		next if (length($line) < 10);
		($acc,$logstring) = ($line =~
		  /^(\d\d\d\d\d\d\d\d\d\d) (\d\d \d\d \d\d\d\d \w)$/);
		$accesses{$logstring} = int($acc);
		($mday,$mon,$year,$type) = ($logstring =~
			  /^(\d+) (\d+) (\d+) (\w)/);
		if ($type eq "E") { $beingshown = 1; $TotalE += int($acc); }
		elsif ($type eq "C") { $beingshown = 1; $TotalC += int($acc); }
		elsif ($type eq "S") { $bannex = 1; $TotalS += int($acc); }
		elsif ($type eq "X") { $bannex = 1; $TotalX += int($acc); }
		else { next; }
		unless ($startday) {
			&date_to_count(int($mon),int($mday),($year-1900));
			$startday = $perp_days;
		}
	}
	&date_to_count(int($mon),int($mday),($year-1900));
	$endday = $perp_days;
	if ((($endday-$startday) > 34) && !($INPUT{'FullDailyList'})) {
		$startday = $endday-34;
		$ShortenedList = 1;
		$TotalE = 0;
		$TotalC = 0;
		$TotalS = 0;
		$TotalX = 0;
		foreach $daycount ($startday..$endday) {
			&count_to_date($daycount);
			if ($perp_mon < 10) { $perp_mon = "0$perp_mon"; }
			if ($perp_day < 10) { $perp_day = "0$perp_day"; }
			$perp_year = $perp_year + 1900;
			$exposures = "$perp_day $perp_mon $perp_year E";
			$clicks = "$perp_day $perp_mon $perp_year C";
			$banners = "$perp_day $perp_mon $perp_year S";
			$clicksfrom = "$perp_day $perp_mon $perp_year X";
			$TotalE += $accesses{$exposures};
			$TotalC += $accesses{$clicks};
			$TotalS += $accesses{$banners};
			$TotalX += $accesses{$clicksfrom};
		}
	}
	&Header("WebAdverts","WebAdverts Administrative Display");
	print "<P ALIGN=CENTER><BIG><BIG><STRONG>Daily Stats for the ";
	print "<EM>$INPUT{'advert'}</EM> Account";
	if ($ShortenedList) {
		print "<BR>(Last Five Weeks Only)";
	}
	elsif ($INPUT{'FullDailyList'}) {
		print "<BR>(Full List)";
	}
	print ":</STRONG></BIG></BIG>\n";
	print "<P><CENTER><TABLE CELLPADDING=3>\n";
	print "<TR ALIGN=CENTER VALIGN=BOTTOM>";
	print "<TD><SMALL><FONT $fontspec><EM>Date</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
	$ColCount = 1;
	if ($bannex) {
		print "<TD NOWRAP COLSPAN=3><SMALL><FONT $fontspec><EM>Banners Shown<BR>";
		print "on Your Site</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
		print "<TD NOWRAP COLSPAN=3><SMALL><FONT $fontspec><EM>Clicks From<BR>";
		print "Your Site</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
		$ColCount += 6;
	}
	if ($beingshown) {
		print "<TD NOWRAP COLSPAN=3><SMALL><FONT $fontspec><EM>Your Banner's<BR>";
		print "Exposures</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
		print "<TD NOWRAP COLSPAN=3><SMALL><FONT $fontspec><EM>Clicks On<BR>";
		print "Your Banner</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
		print "<TD><SMALL><FONT $fontspec><EM>%</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
		print "<TD COLSPAN=3><SMALL><FONT $fontspec><EM>Ratio</EM><BR><HR NOSHADE></FONT></SMALL></TD><TD><SMALL><FONT $fontspec></FONT></SMALL></TD></TR>\n";
		$ColCount += 10;
	}
	$daycounter = (($endday-$startday)+1);
	foreach $daycount ($startday..$endday) {
		print "<TR ALIGN=CENTER>";
		if (($daycount > $startday)
		  && ($daycount-(int($daycount/7)*7)==3)) {
			print "<TD COLSPAN=$ColCount><HR WIDTH=50% NOSHADE>";
			print "</TD></TR>\n";
			print "<TR ALIGN=CENTER>";
		}
		&count_to_date($daycount);
		if ($perp_mon < 10) { $perp_mon = "0$perp_mon"; }
		if ($perp_day < 10) { $perp_day = "0$perp_day"; }
		$perp_year = $perp_year + 1900;
		print "<TD NOWRAP><SMALL><FONT $fontspec>$perp_day $months[$perp_mon-1] $perp_year</FONT></SMALL></TD>";
		$banners = "$perp_day $perp_mon $perp_year S";
		$clicksfrom = "$perp_day $perp_mon $perp_year X";
		$exposures = "$perp_day $perp_mon $perp_year E";
		$clicks = "$perp_day $perp_mon $perp_year C";
		$banners = $accesses{$banners};
		if ($TotalS == 0) { $bannerspercent = 0; }
		else { $bannerspercent=int((($banners/$TotalS)*($daycounter*30))+.5); }
		$clicksfrom = $accesses{$clicksfrom};
		if ($TotalX == 0) { $clicksfrompercent = 0; }
		else { $clicksfrompercent=int((($clicksfrom/$TotalX)*($daycounter*15))+.5); }
		$exposures = $accesses{$exposures};
		if ($TotalE == 0) { $exposurespercent = 0; }
		else { $exposurespercent=int((($exposures/$TotalE)*($daycounter*30))+.5); }
		$clicks = $accesses{$clicks};
		if ($TotalC == 0) { $clickspercent = 0; }
		else { $clickspercent=int((($clicks/$TotalC)*($daycounter*15))+.5); }
		if ($banners < 1) { $banners = "0"; }
		if ($clicksfrom < 1) { $clicksfrom = "0"; }
		if ($exposures < 1) { $exposures = "0"; }
		if ($clicks < 1) { $clicks = "0"; }
		if ($bannex) {
			print "<TD></TD><TD ALIGN=RIGHT><SMALL><FONT $fontspec>",&commas($banners),"</FONT></SMALL></TD>";
			if ($bannerspercent==0) { print "<TD></TD>"; }
			else { print "<TD><HR ALIGN=LEFT SIZE=5 WIDTH=$bannerspercent NOSHADE COLOR=\"#666666\"></TD>"; }
			print "<TD></TD><TD ALIGN=RIGHT><SMALL><FONT $fontspec>",&commas($clicksfrom),"</FONT></SMALL></TD>";
			if ($clicksfrompercent==0) { print "<TD></TD>"; }
			else { print "<TD><HR ALIGN=LEFT SIZE=5 WIDTH=$clicksfrompercent NOSHADE COLOR=\"#666666\"></TD>"; }
		}
		if ($beingshown) {
			print "<TD></TD><TD ALIGN=RIGHT><SMALL><FONT $fontspec>",&commas($exposures),"</FONT></SMALL></TD>";
			if ($exposurespercent==0) { print "<TD></TD>"; }
			else { print "<TD><HR ALIGN=LEFT SIZE=5 WIDTH=$exposurespercent NOSHADE COLOR=\"#666666\"></TD>"; }
			print "<TD></TD><TD ALIGN=RIGHT><SMALL><FONT $fontspec>",&commas($clicks),"</FONT></SMALL></TD>";
			if ($clickspercent==0) { print "<TD></TD>"; }
			else { print "<TD><HR ALIGN=LEFT SIZE=5 WIDTH=$clickspercent NOSHADE COLOR=\"#666666\"></TD>"; }
			if ($exposures == 0) {
				$perc = "-";
				$ratio = "-";
			}
			elsif ($clicks == 0) {
				$perc = "-";
				$ratio = "-";
			}
			else {
				$perc = ((100*($clicks/$exposures))+.05001);
				$ratio = (($exposures/$clicks)+.5001);
			}
			unless ($perc eq "-") {
				$perc =~ s/(\d+\.\d).*/$1/;
				$perc = $perc."%";
			}
			unless ($ratio eq "-") {
				$ratio =~ s/(\d+)\.\d.*/$1/;
				$ratio = $ratio.":1";
			}
			print "<TD><SMALL><FONT $fontspec>$perc</FONT></SMALL></TD>";
			print "<TD></TD><TD><SMALL><FONT $fontspec>$ratio</FONT></SMALL></TD>";
			if ($perc > 0) {
				$perc = int($perc*15);
				print "<TD><HR ALIGN=LEFT SIZE=5 WIDTH=$perc NOSHADE COLOR=\"#666666\"></TD>";
			}
			else { print "<TD></TD>"; }
			print "</TR>\n";
		}
	}
	print "</TABLE></CENTER>\n";
	if ($ShortenedList) {
		print "<P><CENTER><FORM METHOD=POST ";
		print "ACTION=$admin_cgi>\n";
		print "<INPUT TYPE=HIDDEN NAME=password ";
		print "VALUE=$INPUT{'password'}>\n";
		if ($INPUT{'groupstatus'}) {
			print "<INPUT TYPE=HIDDEN NAME=groupstatus ";
			print "VALUE=\"$INPUT{'groupstatus'}\">\n";
		}
		print "<INPUT TYPE=HIDDEN NAME=advert ";
		print "VALUE=$INPUT{'advert'}>\n";
		print "<INPUT TYPE=HIDDEN NAME=FullDailyList ";
		print "VALUE=Yes>\n";
		if ($cryptword) {
			print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
		}
		print "<INPUT TYPE=SUBMIT NAME=dailystats ";
		print "VALUE=\"View Full Daily Stats List\">";
		print "</FORM></CENTER>\n";
	}
	elsif ($INPUT{'FullDailyList'}) {
		print "<P><CENTER><FORM METHOD=POST ";
		print "ACTION=$admin_cgi>\n";
		print "<INPUT TYPE=HIDDEN NAME=password ";
		print "VALUE=$INPUT{'password'}>\n";
		if ($INPUT{'groupstatus'}) {
			print "<INPUT TYPE=HIDDEN NAME=groupstatus ";
			print "VALUE=\"$INPUT{'groupstatus'}\">\n";
		}
		print "<INPUT TYPE=HIDDEN NAME=advert ";
		print "VALUE=$INPUT{'advert'}>\n";
		if ($cryptword) {
			print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
		}
		print "<INPUT TYPE=SUBMIT NAME=dailystats ";
		print "VALUE=\"View Daily Stats for Last Five Weeks Only\">";
		print "</FORM></CENTER>\n";
	}
	print "<P><CENTER><TABLE><TR ALIGN=CENTER>\n";
	print "<FORM METHOD=POST ACTION=$admin_cgi><TD><SMALL><FONT $fontspec>\n";
	print "<INPUT TYPE=HIDDEN NAME=password ";
	print "VALUE=$INPUT{'password'}>\n";
	if ($cryptword) {
		print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
	}
	print "<INPUT TYPE=HIDDEN NAME=reviewone VALUE=";
	if ($INPUT{'groupstatus'}) {
		print "\"$INPUT{'groupstatus'}\"";
	}
	else {
		print "$INPUT{'advert'}";
	}
	print ">\n";
	print "<INPUT TYPE=SUBMIT ";
	print "VALUE=\"View Overall Stats\"> ";
	print "</FONT></SMALL></TD></FORM>\n";
	print "<FORM METHOD=POST ACTION=$admin_cgi><TD><SMALL><FONT $fontspec>\n";
	print "<INPUT TYPE=HIDDEN NAME=password ";
	print "VALUE=$INPUT{'password'}>\n";
	if ($groupstatus) {
		print "<INPUT TYPE=HIDDEN NAME=groupstatus ";
		print "VALUE=\"$groupstatus\">\n";
	}
	print "<INPUT TYPE=HIDDEN NAME=advert VALUE=$INPUT{'advert'}>\n";
	if ($cryptword) {
		print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
	}
	print "<INPUT TYPE=SUBMIT NAME=monthlystats ";
	print "VALUE=\"View Monthly Stats\">";
	print "</FONT></SMALL></TD></FORM>\n";
	if ($LogIP) {
		print "<FORM METHOD=POST ";
		print "ACTION=$admin_cgi><TD><SMALL><FONT $fontspec>\n";
		print "<INPUT TYPE=HIDDEN NAME=password ";
		print "VALUE=$INPUT{'password'}>\n";
		if ($INPUT{'groupstatus'}) {
			print "<INPUT TYPE=HIDDEN NAME=groupstatus ";
			print "VALUE=\"$INPUT{'groupstatus'}\">\n";
		}
		print "<INPUT TYPE=HIDDEN NAME=advert ";
		print "VALUE=$INPUT{'advert'}>\n";
		if ($cryptword) {
			print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
		}
		print "<INPUT TYPE=SUBMIT NAME=iplog ";
		print "VALUE=\"View IP Address Log\">";
		print "</FONT></SMALL></TD></FORM>\n";
	}
	print "</TR></TABLE></CENTER>\n";
	&Footer;
}

sub monthlystats {
	&ConfirmUserPassword;
	open (DISPLAY, "<$adverts_dir/$INPUT{'advert'}.log") || &Error_NoStats;
	@lines = <DISPLAY>;
	close (DISPLAY);
	foreach $line (@lines) {
		next if (length($line) < 10);
		($acc,$logstring) = ($line =~
		  /^(\d\d\d\d\d\d\d\d\d\d) \d\d (\d\d \d\d\d\d \w)$/);
		$accesses{$logstring} += int($acc);
		($mon,$year,$type) = ($logstring =~
			  /^(\d+) (\d+) (\w)/);
		if ($type eq "E") { $beingshown = 1; $TotalE += int($acc); }
		elsif ($type eq "C") { $beingshown = 1; $TotalC += int($acc); }
		elsif ($type eq "S") { $bannex = 1; $TotalS += int($acc); }
		elsif ($type eq "X") { $bannex = 1; $TotalX += int($acc); }
		else { next; }
		unless ($startyear) {
			$startyear = $year;
			$startmon = $mon;
		}
	}
	$endyear = $year;
	$endmon = $mon;
	&Header("WebAdverts","WebAdverts Administrative Display");
	print "<P ALIGN=CENTER><BIG><BIG><STRONG>Monthly Stats for the ";
	print "<EM>$INPUT{'advert'}</EM> Account";
	print ":</STRONG></BIG></BIG>\n";
	print "<P><CENTER><TABLE CELLPADDING=3>\n";
	print "<TR ALIGN=CENTER VALIGN=BOTTOM>";
	print "<TD><SMALL><FONT $fontspec><EM>Month</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
	if ($bannex) {
		print "<TD NOWRAP COLSPAN=3><SMALL><FONT $fontspec><EM>Banners Shown<BR>";
		print "on Your Site</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
		print "<TD NOWRAP COLSPAN=3><SMALL><FONT $fontspec><EM>Clicks From<BR>";
		print "Your Site</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
	}
	if ($beingshown) {
		print "<TD NOWRAP COLSPAN=3><SMALL><FONT $fontspec><EM>Your Banner's<BR>";
		print "Exposures</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
		print "<TD NOWRAP COLSPAN=3><SMALL><FONT $fontspec><EM>Clicks On<BR>";
		print "Your Banner</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
		print "<TD><SMALL><FONT $fontspec><EM>%</EM><BR><HR NOSHADE></FONT></SMALL></TD>";
		print "<TD COLSPAN=3><SMALL><FONT $fontspec><EM>Ratio</EM><BR><HR NOSHADE></FONT></SMALL></TD><TD><SMALL><FONT $fontspec></FONT></SMALL></TD></TR>\n";
	}
	foreach $year ($startyear..$endyear) {
		if ($year == $startyear) { $firstmon = $startmon; }
		else { $firstmon = "01"; }
		if ($year == $endyear) { $lastmon = $endmon; }
		else { $lastmon = 12; }
		foreach $month ($firstmon..$lastmon) {
			$monthcounter++;
		}
	}
	foreach $year ($startyear..$endyear) {
		if ($year == $startyear) { $firstmon = $startmon; }
		else { $firstmon = "01"; }
		if ($year == $endyear) { $lastmon = $endmon; }
		else { $lastmon = 12; }
		foreach $month ($firstmon..$lastmon) {
			print "<TR ALIGN=CENTER>";
			print "<TD NOWRAP><SMALL><FONT $fontspec>$months[$month-1] $year</FONT></SMALL></TD>";
			$banners = "$month $year S";
			$clicksfrom = "$month $year X";
			$exposures = "$month $year E";
			$clicks = "$month $year C";
			$banners = $accesses{$banners};
			if ($TotalS == 0) { $bannerspercent = 0; }
			else { $bannerspercent=int((($banners/$TotalS)*($monthcounter*30))+.5); }
			$clicksfrom = $accesses{$clicksfrom};
			if ($TotalX == 0) { $clicksfrompercent = 0; }
			else { $clicksfrompercent=int((($clicksfrom/$TotalX)*($monthcounter*15))+.5); }
			$exposures = $accesses{$exposures};
			if ($TotalE == 0) { $exposurespercent = 0; }
			else { $exposurespercent=int((($exposures/$TotalE)*($monthcounter*30))+.5); }
			$clicks = $accesses{$clicks};
			if ($TotalC == 0) { $clickspercent = 0; }
			else { $clickspercent=int((($clicks/$TotalC)*($monthcounter*15))+.5); }
			if ($banners < 1) { $banners = "0"; }
			if ($clicksfrom < 1) { $clicksfrom = "0"; }
			if ($exposures < 1) { $exposures = "0"; }
			if ($clicks < 1) { $clicks = "0"; }
			if ($bannex) {
				print "<TD></TD><TD ALIGN=RIGHT><SMALL><FONT $fontspec>",&commas($banners),"</FONT></SMALL></TD>";
				if ($bannerspercent==0) { print "<TD></TD>"; }
				else { print "<TD><HR ALIGN=LEFT SIZE=5 WIDTH=$bannerspercent NOSHADE COLOR=\"#666666\"></TD>"; }
				print "<TD></TD><TD ALIGN=RIGHT><SMALL><FONT $fontspec>",&commas($clicksfrom),"</FONT></SMALL></TD>";
				if ($clicksfrompercent==0) { print "<TD></TD>"; }
				else { print "<TD><HR ALIGN=LEFT SIZE=5 WIDTH=$clicksfrompercent NOSHADE COLOR=\"#666666\"></TD>"; }
			}
			if ($beingshown) {
				print "<TD></TD><TD ALIGN=RIGHT><SMALL><FONT $fontspec>",&commas($exposures),"</FONT></SMALL></TD>";
				if ($exposurespercent==0) { print "<TD></TD>"; }
				else { print "<TD><HR ALIGN=LEFT SIZE=5 WIDTH=$exposurespercent NOSHADE COLOR=\"#666666\"></TD>"; }
				print "<TD></TD><TD ALIGN=RIGHT><SMALL><FONT $fontspec>",&commas($clicks),"</FONT></SMALL></TD>";
				if ($clickspercent==0) { print "<TD></TD>"; }
				else { print "<TD><HR ALIGN=LEFT SIZE=5 WIDTH=$clickspercent NOSHADE COLOR=\"#666666\"></TD>"; }
				if ($exposures == 0) {
					$perc = "-";
					$ratio = "-";
				}
				elsif ($clicks == 0) {
					$perc = "-";
					$ratio = "-";
				}
				else {
					$perc = ((100*($clicks/$exposures))+.05001);
					$ratio = (($exposures/$clicks)+.5001);
				}
				unless ($perc eq "-") {
					$perc =~ s/(\d+\.\d).*/$1/;
					$perc = $perc."%";
				}
				unless ($ratio eq "-") {
					$ratio =~ s/(\d+)\.\d.*/$1/;
					$ratio = $ratio.":1";
				}
				print "<TD><SMALL><FONT $fontspec>$perc</FONT></SMALL></TD>";
				print "<TD></TD><TD><SMALL><FONT $fontspec>$ratio</FONT></SMALL></TD>";
				if ($perc > 0) {
					$perc = int($perc*15);
					print "<TD><HR ALIGN=LEFT SIZE=5 WIDTH=$perc NOSHADE COLOR=\"#666666\"></TD>";
				}
				else { print "<TD></TD>"; }
				print "</TR>\n";
			}
		}
	}
	print "</TABLE></CENTER>\n";
	print "<P><CENTER><TABLE><TR ALIGN=CENTER>\n";
	print "<FORM METHOD=POST ACTION=$admin_cgi><TD><SMALL><FONT $fontspec>\n";
	print "<INPUT TYPE=HIDDEN NAME=password ";
	print "VALUE=$INPUT{'password'}>\n";
	if ($cryptword) {
		print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
	}
	print "<INPUT TYPE=HIDDEN NAME=reviewone VALUE=";
	if ($INPUT{'groupstatus'}) {
		print "\"$INPUT{'groupstatus'}\"";
	}
	else {
		print "$INPUT{'advert'}";
	}
	print ">\n";
	print "<INPUT TYPE=SUBMIT ";
	print "VALUE=\"View Overall Stats\"> ";
	print "</FONT></SMALL></TD></FORM>\n";
	print "<FORM METHOD=POST ";
	print "ACTION=$admin_cgi><TD><SMALL><FONT $fontspec>\n";
	print "<INPUT TYPE=HIDDEN NAME=password ";
	print "VALUE=$INPUT{'password'}>\n";
	if ($INPUT{'groupstatus'}) {
		print "<INPUT TYPE=HIDDEN NAME=groupstatus ";
		print "VALUE=\"$INPUT{'groupstatus'}\">\n";
	}
	print "<INPUT TYPE=HIDDEN NAME=advert ";
	print "VALUE=$INPUT{'advert'}>\n";
	if ($cryptword) {
		print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
	}
	print "<INPUT TYPE=SUBMIT NAME=dailystats ";
	print "VALUE=\"View Daily Stats\">";
	print "</FONT></SMALL></TD></FORM>\n";
	if ($LogIP) {
		print "<FORM METHOD=POST ";
		print "ACTION=$admin_cgi><TD><SMALL><FONT $fontspec>\n";
		print "<INPUT TYPE=HIDDEN NAME=password ";
		print "VALUE=$INPUT{'password'}>\n";
		if ($INPUT{'groupstatus'}) {
			print "<INPUT TYPE=HIDDEN NAME=groupstatus ";
			print "VALUE=\"$INPUT{'groupstatus'}\">\n";
		}
		print "<INPUT TYPE=HIDDEN NAME=advert ";
		print "VALUE=$INPUT{'advert'}>\n";
		if ($cryptword) {
			print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
		}
		print "<INPUT TYPE=SUBMIT NAME=iplog ";
		print "VALUE=\"View IP Address Log\">";
		print "</FONT></SMALL></TD></FORM>\n";
	}
	print "</TR></TABLE></CENTER>\n";
	&Footer;
}

sub iplog {
	&ConfirmUserPassword;
	&Header("WebAdverts","WebAdverts Administrative Display");
	print "<P ALIGN=CENTER><BIG><BIG><STRONG>IP Address Log for the ",
	  "<EM>$INPUT{'advert'}</EM> Account:</STRONG></BIG></BIG>\n",
	  "<P>The following log file lists ",
	  "the IP addresses of those individuals who ",
	  "have seen or clicked on this account's banner ",
	  "since yesterday morning. Each ",
	  "line displays the time of the exposure (E) ",
	  "or click-thru (C), and the IP ",
	  "address of the responsible party.\n",
	  "<P><FONT FACE=\"Courier\"><PRE>";
	($mday,$mon) = (localtime($time-86400))[3,4];
	if ($mday < 10) { $mday = "0".$mday; }
	$mon++;
	if ($mon < 10) { $mon = "0".$mon; }
	open (DISPLAY, "$adverts_dir/$INPUT{'advert'}.$mon$mday.log");
	&ShowIPs;
	close (DISPLAY);
	($mday,$mon) = (localtime($time))[3,4];
	if ($mday < 10) { $mday = "0".$mday; }
	$mon++;
	if ($mon < 10) { $mon = "0".$mon; }
	open (DISPLAY, "$adverts_dir/$INPUT{'advert'}.$mon$mday.log");
	&ShowIPs;
	close (DISPLAY);
	print "</PRE></FONT>\n";
	print "<P>Total exposures logged: <STRONG>",&commas($ExposureCount),"</STRONG>\n";
	print "<BR>Total clicks logged: <STRONG>",&commas($ClickCount),"</STRONG>\n";
	print "<BR>Total IP addresses logged: <STRONG>",&commas($IPCount),"</STRONG>\n";
	if ($IPCount<1) { $AverageEntries = 0; }
	else { $AverageEntries = (($ExposureCount+$ClickCount)/$IPCount)+.05; }
	if ($AverageEntries < 10) {
		$AverageEntries =~ s/(...).*/$1/;
	}
	else {
		$AverageEntries =~ s/(....).*/$1/;
	}
	print "<P>Average log entries per IP address: <STRONG>${AverageEntries}</STRONG>\n";
	print "<P><CENTER><TABLE><TR ALIGN=CENTER>\n";
	print "<FORM METHOD=POST ACTION=$admin_cgi><TD><SMALL><FONT $fontspec>\n";
	print "<INPUT TYPE=HIDDEN NAME=password ";
	print "VALUE=$INPUT{'password'}>\n";
	if ($cryptword) {
		print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
	}
	print "<INPUT TYPE=HIDDEN NAME=reviewone VALUE=";
	if ($INPUT{'groupstatus'}) {
		print "\"$INPUT{'groupstatus'}\"";
	}
	else {
		print "$INPUT{'advert'}";
	}
	print ">\n";
	print "<INPUT TYPE=SUBMIT ";
	print "VALUE=\"View Overall Stats\"> ";
	print "</FONT></SMALL></TD></FORM>\n";
	print "<FORM METHOD=POST ";
	print "ACTION=$admin_cgi><TD><SMALL><FONT $fontspec>\n";
	print "<INPUT TYPE=HIDDEN NAME=password ";
	print "VALUE=$INPUT{'password'}>\n";
	if ($INPUT{'groupstatus'}) {
		print "<INPUT TYPE=HIDDEN NAME=groupstatus ";
		print "VALUE=\"$INPUT{'groupstatus'}\">\n";
	}
	print "<INPUT TYPE=HIDDEN NAME=advert ";
	print "VALUE=$INPUT{'advert'}>\n";
	if ($cryptword) {
		print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
	}
	print "<INPUT TYPE=SUBMIT NAME=dailystats ";
	print "VALUE=\"View Daily Stats\">";
	print "</FONT></SMALL></TD></FORM>\n";
	print "<FORM METHOD=POST ACTION=$admin_cgi><TD><SMALL><FONT $fontspec>\n";
	print "<INPUT TYPE=HIDDEN NAME=password ";
	print "VALUE=$INPUT{'password'}>\n";
	if ($groupstatus) {
		print "<INPUT TYPE=HIDDEN NAME=groupstatus ";
		print "VALUE=\"$groupstatus\">\n";
	}
	print "<INPUT TYPE=HIDDEN NAME=advert VALUE=$INPUT{'advert'}>\n";
	if ($cryptword) {
		print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
	}
	print "<INPUT TYPE=SUBMIT NAME=monthlystats ";
	print "VALUE=\"View Monthly Stats\">";
	print "</FONT></SMALL></TD></FORM>\n";
	print "</TR></TABLE></CENTER>\n";
	&Footer;
}

sub ShowIPs {
	while (<DISPLAY>) {
		next if (length($_) < 5);	
		unless ($NoPrintIPs) { print "$mon/$mday $_"; }
		if (/E ([^\s]*)\n/) {
			$ExposureCount ++;
			$ThisIP = $1;
		}
		elsif (/C ([^\s]*)\n/) {
			$ClickCount ++;
			$ThisIP = $1;
		}
		$IPCount{$ThisIP} ++;
		if ($IPCount{$ThisIP} == 1) {
			$IPCount ++;
		}
	}
}

sub masteriplog {
	&ConfirmAdminPassword(1);
	&Header("WebAdverts","WebAdverts Administrative Display");
	print "<P ALIGN=CENTER><BIG><BIG><STRONG>",
	  "Master IP Address Report</STRONG></BIG></BIG>\n",
	  "<P>The following report details the IP addresses ",
	  "which have seen or clicked on banners in the rotation ",
	  "since yesterday morning.\n";
	$NoPrintIPs = 1;
	($mday1,$mon1) = (localtime($time-86400))[3,4];
	if ($mday1 < 10) { $mday1 = "0".$mday1; }
	$mon1++;
	($mday2,$mon2) = (localtime($time))[3,4];
	if ($mday2 < 10) { $mday2 = "0".$mday2; }
	$mon2++;
	opendir (FILES,$adverts_dir);
	@files = readdir(FILES);
	closedir (FILES);
	foreach $file (@files) {
		next unless (($file=~/$mon1$mday1.log/) || ($file=~/$mon2$mday2.log/));
		open (DISPLAY, "$adverts_dir/$file");
		&ShowIPs;
		close (DISPLAY);
	}
	print "<P>Total exposures logged: <STRONG>",&commas($ExposureCount),"</STRONG>\n";
	print "<BR>Total clicks logged: <STRONG>",&commas($ClickCount),"</STRONG>\n";
	print "<BR>Total IP addresses logged: <STRONG>",&commas($IPCount),"</STRONG>\n";
	if ($IPCount<1) { $AverageEntries = 0; }
	else { $AverageEntries = (($ExposureCount+$ClickCount)/$IPCount)+.05; }
	if ($AverageEntries < 10) {
		$AverageEntries =~ s/(...).*/$1/;
	}
	else {
		$AverageEntries =~ s/(....).*/$1/;
	}
	print "<P>Average log entries per IP address: <STRONG>${AverageEntries}</STRONG>\n";
	print "<P><STRONG>The Top 25 Most Active IP Addresses:</STRONG>\n";
	print "<FONT FACE=\"Courier\"><PRE>\n";
	foreach $key (sort ByCount keys(%IPCount)) {
		last if ($Counter > 24);
		$ip = $key;
		if ($ip =~ /\d+\.\d+\.\d+\.\d+/) {
			@domainbytes = split(/\./,$ip);
			$packaddr = pack("C4",@domainbytes);
			$resolvedip = (gethostbyaddr($packaddr, 2))[0];
			unless ($resolvedip =~
			  /^[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})$/) {
				$resolvedip = "";
			}
			if ($resolvedip) {
				$ip = "$ip ($resolvedip)";
			}
		}
		printf "%10s%-s\n",&commas($IPCount{$key}),"       $ip";
		$Counter++;
	}
	print "</PRE></FONT>\n";
	&LinkBack;
	&Footer;
}

sub ByCount {
	$IPCount{$b}<=>$IPCount{$a};
}

sub ShowAdvert {
	if ($raw || $image) {
		print "<CENTER><P><TABLE BORDER=1 CELLSPACING=0 CELLPADDING=12><TR><TD>\n";
	}
	@image = split (/\|/,$image);
	if ($raw) {
		srand();
		$rand = int(rand(100))+1;
		$realraw = $raw;
		$realraw =~ s/<NLB>/\n/g;
		$realraw =~ s/<RAND>/$rand/g;
		$realraw =~ s/<URL>//g;
		print "$realraw\n";
	}
	else {
		foreach $image (@image) {
			if ($NotFirst) { print "<P>"; }
			else { $NotFirst=1; }
			if ($url) {
				print "<A HREF=\"$url\"";
				if ($target eq "_top") { print " TARGET=\"$target\""; }
				elsif ($target) { print " $target"; }
				print ">";
			}
			print "<IMG SRC=\"$image\"";
			if ($ExchangeLogo && $ExchangeBannerHeight && $ExchangeBannerWidth) {
				print " HEIGHT=$ExchangeBannerHeight WIDTH=$ExchangeBannerWidth";
			}
			elsif ($height && $width) {
				print " HEIGHT=$height WIDTH=$width";
			}
			print " ALT=\"$alt\"";
			unless ($border) { $border="0"; }
			print " BORDER=$border>";
			if ($url) { print "</A>"; }
			print "\n";
		}
	}
	if ($raw || $image) {
		print "</TD></TR></TABLE></CENTER>\n";
	}
	if ($url) {
		print "<P ALIGN=CENTER>Destination: ";
		print "<A HREF=\"$url\">$url</A>\n";
	}
	if ($username || $email) {
		if ($url) { print "<BR>"; }
		else { print "<P ALIGN=CENTER>"; }
		print "Account Holder: ";
		if ($email) {
			print "<A HREF=\"mailto:$email\">";
		}
		if ($username) { print "$username"; }
		else { print "$email"; }
		if ($email) {
			print "</A>";
		}
		print "\n";
	}
}

sub adminlog {
	&ConfirmAdminPassword(1);
	&Header("WebAdverts","WebAdverts Administrative Display");
	print "<P ALIGN=CENTER><BIG><BIG><STRONG>",
	  "Admin Accesses Report</STRONG></BIG></BIG>\n",
	  "<P>The following report lists the IP addresses ",
	  "which have accessed administrative functions.\n";
	print "<FONT FACE=\"Courier\"><PRE>\n";
	open (ADMINLOG,"$adverts_dir/adminlog.txt");
	while (<ADMINLOG>) { print "$_"; }
	close (ADMINLOG);
	print "</PRE></FONT>\n";
	&LinkBack;
	&Footer;
}

sub edit {
	&ConfirmAdminPassword(1);
	if ($INPUT{'reviewone'} && !($INPUT{'editad'})) {
		$INPUT{'editad'} = $INPUT{'reviewone'};
	}
	$INPUT{'editad'} =~ s/[^\w_-]//g;
	$INPUT{'editad'} =~ tr/A-Z/a-z/;
	&CheckName($INPUT{'editad'});
	if (-s "$adverts_dir/$INPUT{'editad'}.txt") {
		open (DISPLAY, "<$adverts_dir/$INPUT{'editad'}.txt");
		@lines = <DISPLAY>;
		close (DISPLAY);
		foreach $line (@lines) {
			chop ($line) if ($line =~ /\n$/);
			$line =~ s/&/&amp;/g;
			$line =~ s/>/&gt;/g;
			$line =~ s/</&lt;/g;
			$line =~ s/"/&quot;/g;
		}
		($max,$shown,$visits,$url,$image,$height,$width,
		  $alt,$pass,$text,$start,$weight,$zone,
		  $border,$target,$raw,$displayratio,$username,$email,
		  $displayzone,$clicksfrom) = @lines;
		($max,$maxtype) = split (/\|/, $max);
		($text,$texttype) = split (/\|/, $text);
		($displayratio,$displaycount) = split (/\|/, $displayratio);
	}
	unless ($weight) {
		if ($maxtype || $displayratio) { $weight = "0"; }
		else { $weight = $DefaultWeight; }
	}
	unless ($border) {
		if ($maxtype || $displayratio) { $border = "0"; }
		else { $border = $DefaultBorder; }
	}
	unless ($maxtype) { $maxtype = "E"; }
	unless ($texttype) { $texttype = "B"; }
	unless ($url) { $url = "http://"; }
	$image =~ s/\|/\n/g;
	unless ($image) { $image = "http://"; }
	if ($target eq "_top") { $target = "TARGET=&quot;_top&quot;"; }
	if ($DefaultLinkAttribute && !($target)) {
		$target = $DefaultLinkAttribute;
	}
	&Header("WebAdverts","Add/Edit/Delete Account");
	print "<FORM METHOD=POST ACTION=$admin_cgi>\n";
	print "<P ALIGN=CENTER><BIG><STRONG>Info for the ",
	  "<EM>$INPUT{'editad'}</EM> Account:",
	  "</STRONG></BIG>\n",
	  "<P><CENTER><TABLE CELLPADDING=3>\n",
	  "<TR><TD COLSPAN=2><HR WIDTH=50%></TD></TR>\n",
	  "<TR><TD COLSPAN=2><SMALL><FONT $fontspec>",
	  "<STRONG>I. General Information</STRONG>: ",
	  "The following information is needed for each account, ",
	  "no matter <EM>how</EM> you're setting things up. Note ",
	  "that while <EM>either</EM> an expiration or a display ",
	  "ratio must be set, it is not necessary to set both. ",
	  "If you're running a &quot;banner exchange,&quot; ",
	  "the display ratio will define how many banner displays ",
	  "earn one exposure. If you're running straight adverts, ",
	  "leave it set to 0, and simply set the appropriate ",
	  "expiration criteria instead. (If you're running ",
	  "an exchange, but want a member to get extra ",
	  "&quot;bonus&quot; exposures, set that bonus number ",
	  "in the &quot;expiration&quot; slot.)</FONT></SMALL></TD></TR>\n",
	  "<TR><TD><SMALL><FONT $fontspec>Name:</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=username VALUE=\"$username\" SIZE=50></FONT></SMALL></TD></TR>\n",
	  "<TR><TD><SMALL><FONT $fontspec>E-Mail:</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=email VALUE=\"$email\" SIZE=50></FONT></SMALL></TD></TR>\n";
	if ($start > $time) {
		$startday = int((($start-$time)/86400)+.5);
	}
	print "<TR><TD><SMALL><FONT $fontspec>Start Day:</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=startday VALUE=\"$startday\" SIZE=5>",
	  "<BR><SMALL><EM>(Input the number of days ",
	  "in which the account should ",
	  "start running, or leave blank ",
	  "to start the run immediately.)</EM></SMALL>",
	  "</FONT></SMALL></TD></TR>\n";
	if ($maxtype eq "D") {
		$max = int((($max-$time)/86400)+.5);
		if ($max < 0) { $max = 0; }
	}
	print "<TR><TD><SMALL><FONT $fontspec>Expiration:";
	print "</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ";
	print "NAME=purch VALUE=\"$max\" SIZE=25>";
	print "<BR><INPUT TYPE=RADIO NAME=purchtype VALUE=N";
	if ($maxtype eq "N") { print " CHECKED"; }
	print "> Never Expires <INPUT TYPE=RADIO NAME=purchtype VALUE=E";
	if ($maxtype eq "E") { print " CHECKED"; }
	print "> Exposures <INPUT TYPE=RADIO NAME=purchtype VALUE=C";
	if ($maxtype eq "C") { print " CHECKED"; }
	print "> Clicks <INPUT TYPE=RADIO NAME=purchtype VALUE=D";
	if ($maxtype eq "D") { print " CHECKED"; }
	print "> Days\n";
	print "<BR><SMALL><EM>(Input the maximum number of exposures, ",
	  "click-thrus or days to be allowed for the run.)</EM></SMALL>",
	  "</FONT></SMALL></TD></TR>\n",
	  "<TR><TD><SMALL><FONT $fontspec>Display Ratio:</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=displayratio VALUE=\"$displayratio\" SIZE=5>",
	  "</FONT></SMALL></TD></TR>\n",
	  "<TR><TD><SMALL><FONT $fontspec>Site URL:</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=url VALUE=\"$url\" SIZE=50></FONT></SMALL></TD></TR>\n",
	  "<TR><TD><SMALL><FONT $fontspec>Banner URL(s):</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\">",
	  "<TEXTAREA COLS=50 ROWS=5 NAME=image WRAP=VIRTUAL>",
	  "$image</TEXTAREA></FONT></SMALL></TD></TR>\n",
	  "<TR><TD><SMALL><FONT $fontspec>Weight (Wt.):</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=weight VALUE=\"$weight\" SIZE=5>",
	  "<BR><SMALL><EM>(0 = never; 1 = always; ",
	  "higher numbers = less often)</EM></SMALL>",
	  "</FONT></SMALL></TD></TR>\n";
	if (%nonssi_cgis) {
		print "<TR><TD VALIGN=TOP><SMALL><FONT $fontspec>Zone(s):</FONT></SMALL></TD><TD><SMALL><FONT $fontspec>";
		foreach $setzone (sort (keys %nonssi_cgis)) {
			print "<INPUT TYPE=CHECKBOX NAME=zone ";
			print "VALUE=\"$setzone\"";
			if ($zone =~ /$setzone/) {
				print " CHECKED";
			}
			print ">$setzone\n<BR>";
		}
		print "<SMALL><EM>(Select target categories of pages ";
		print "on which this banner should be displayed.)</EM></SMALL>";
		print "</FONT></SMALL></TD></TR>\n";
		print "<TR><TD></TD><TD><SMALL><FONT FACE=\"Courier\"><SELECT NAME=displayzone>";
		foreach $setzone (sort (keys %nonssi_cgis)) {
			print "<OPTION";
			if ($displayzone eq $setzone) {
				print " SELECTED";
			}
			print ">$setzone";
		}
		print "</SELECT></FONT><FONT $fontspec>";
		print "<BR><SMALL><EM>(If this advertiser is an exchange member, ";
		print "select the category of banners to be displayed on ";
		print "his or her pages.)</EM></SMALL>";
		print "</FONT></SMALL></TD></TR>\n";
	}
	else {
		print "<TR><TD><SMALL><FONT $fontspec>Zone(s):</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ";
		print "NAME=zone VALUE=\"$zone\" SIZE=25></FONT></SMALL></TD></TR>\n";
	}
	print "<TR><TD><SMALL><FONT $fontspec>Password:</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=pass VALUE=\"$pass\" SIZE=50></FONT></SMALL></TD></TR>\n",
	  "<TR><TD COLSPAN=2><HR WIDTH=50%></TD></TR>\n",
	  "<TR><TD COLSPAN=2><SMALL><FONT $fontspec>",
	  "<STRONG>II. SSI Account Information</STRONG>: ",
	  "The following information is used to define or modify ",
	  "the &quot;appearance&quot; of an account banner when ",
	  "called via an SSI tag. None of it is necessary ",
	  "(or even useful) if the banner is called only via IMG ",
	  "tags.</FONT></SMALL></TD></TR>\n",
	  "<TR><TD><SMALL><FONT $fontspec>Link Attributes:</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=target VALUE=\"$target\" SIZE=50></FONT></SMALL></TD></TR>\n",
	  "<TR><TD><SMALL><FONT $fontspec>Banner Width:</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=width VALUE=\"$width\" SIZE=5> pixels</FONT></SMALL></TD></TR>\n",
	  "<TR><TD><SMALL><FONT $fontspec>Banner Height:</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=height VALUE=\"$height\" SIZE=5> pixels</FONT></SMALL></TD></TR>\n",
	  "<TR><TD><SMALL><FONT $fontspec>Border:</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=border VALUE=\"$border\" SIZE=5></FONT></SMALL></TD></TR>\n",
	  "<TR><TD><SMALL><FONT $fontspec>ALT Text:</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=alt VALUE=\"$alt\" SIZE=50></FONT></SMALL></TD></TR>\n",
	  "<TR><TD><SMALL><FONT $fontspec>Link Text:</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=text VALUE=\"$text\" SIZE=50>",
	  "<BR><INPUT TYPE=RADIO NAME=texttype VALUE=T";
	if ($texttype eq "T") { print " CHECKED"; }
	print "> Above Banner <INPUT TYPE=RADIO NAME=texttype VALUE=B";
	if ($texttype eq "B") { print " CHECKED"; }
	print "> Below Banner</FONT></SMALL></TD></TR>\n",
	  "<TR><TD COLSPAN=2><HR WIDTH=50%></TD></TR>\n",
	  "<TR><TD COLSPAN=2><SMALL><FONT $fontspec>",
	  "<STRONG>III. &quot;Raw Mode&quot; Information</STRONG>: ",
	  "If you so choose, you can specify below <EM>exactly</EM> ",
	  "how a banner is to appear on your pages. (Again, of ",
	  "course, this is only possible if you're using SSI tags; ",
	  "&quot;raw mode&quot; and non-SSI display are ",
	  "incompatible.) <EM>Only use this option if you're sure ",
	  "you know what you're doing; anything input here will ",
	  "override just about everything above!</EM></FONT></SMALL></TD></TR>\n",
	  "<TR><TD><SMALL><FONT $fontspec>&quot;Raw&quot; HTML:</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\">",
	  "<TEXTAREA COLS=50 ROWS=5 NAME=raw WRAP=VIRTUAL>";
	$raw =~ s/&lt;NLB&gt;/\n/g;
	print "$raw</TEXTAREA></FONT></SMALL></TD></TR>\n",
	  "<TR><TD COLSPAN=2><HR WIDTH=50%></TD></TR>\n",
	  "</TABLE>\n",
	  "<P><INPUT TYPE=HIDDEN NAME=editad ",
	  "VALUE=\"$INPUT{'editad'}\">\n",
	  "<INPUT TYPE=HIDDEN NAME=start VALUE=\"$start\">\n",
	  "<INPUT TYPE=HIDDEN NAME=password ",
	  "VALUE=$INPUT{'password'}>\n",
	  "Check here to reset account exposures &amp; clicks: ",
	  "<INPUT TYPE=CHECKBOX NAME=\"resetadvert\">";
	if (-s "$adverts_dir/welcome.txt") {
		print "<BR>Check here to send a welcome letter: ",
		  "<INPUT TYPE=CHECKBOX NAME=\"welcomeletter\">";
	}
	if ($cryptword) {
		print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
	}
	print "<P><INPUT TYPE=SUBMIT NAME=editfinal ";
	print "VALUE=\"Add/Edit Account\">\n";
	if (-s "$adverts_dir/$INPUT{'editad'}.txt") {
		if ((-s "$adverts_dir/reject.txt") && $email) {
			print "<P>Check here to send a rejection letter: ",
			  "<INPUT TYPE=CHECKBOX NAME=\"rejectionletter\" VALUE=\"$email\">";
		}
		print "<P><INPUT TYPE=SUBMIT NAME=del ";
		print "VALUE=\"Delete Account\"> ";
		print "<INPUT TYPE=HIDDEN NAME=delad ";
		print "VALUE=\"$INPUT{'editad'}\">\n";
	}
	print "</CENTER></FORM>\n";
	&Footer;
}

sub UserEdit {
	$INPUT{'reviewone'} =~ s/[^\w_-]//g;
	$INPUT{'reviewone'} =~ tr/A-Z/a-z/;
	&CheckName($INPUT{'reviewone'});
	if (-s "$adverts_dir/$INPUT{'reviewone'}.txt") {
		open (DISPLAY, "<$adverts_dir/$INPUT{'reviewone'}.txt");
		@lines = <DISPLAY>;
		close (DISPLAY);
		foreach $line (@lines) {
			chop ($line) if ($line =~ /\n$/);
			$line =~ s/&/&amp;/g;
			$line =~ s/>/&gt;/g;
			$line =~ s/</&lt;/g;
			$line =~ s/"/&quot;/g;
		}
		($max,$shown,$visits,$url,$image,$height,$width,
		  $alt,$pass,$text,$start,$weight,$zone,
		  $border,$target,$raw,$displayratio,$username,$email,
		  $displayzone,$clicksfrom) = @lines;
		unless ($INPUT{'password'} eq $pass) {
			&ConfirmAdminPassword(2);
		}
	}
	else {
		$pass = $INPUT{'password'};
	}
	unless ($url) { $url = "http://"; }
	$image =~ s/\|/\n/g;
	unless ($image) { $image = "http://"; }
	&Header("WebAdverts","Add/Edit/Delete Account");
	print "<FORM METHOD=POST ACTION=$admin_cgi>\n",
	  "<P ALIGN=CENTER><BIG><STRONG>Info for the ",
	  "<EM>$INPUT{'reviewone'}</EM> Account:",
	  "</STRONG></BIG>\n",
	  "<P><CENTER><TABLE CELLPADDING=3>\n",
	  "<TR><TD COLSPAN=2><HR WIDTH=50%></TD></TR>\n",
	  "<TR><TD><SMALL><FONT $fontspec>Name:</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=username VALUE=\"$username\" SIZE=50></FONT></SMALL></TD></TR>\n",
	  "<TR><TD><SMALL><FONT $fontspec>E-Mail:</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=email VALUE=\"$email\" SIZE=50></FONT></SMALL></TD></TR>\n",
	  "<TR><TD><SMALL><FONT $fontspec>Site URL:</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=url VALUE=\"$url\" SIZE=50></FONT></SMALL></TD></TR>\n",
	  "<TR><TD><SMALL><FONT $fontspec>Banner URL(s):</FONT></SMALL></TD><TD><SMALL><FONT FACE=\"Courier\">",
	  "<TEXTAREA COLS=50 ROWS=5 NAME=image WRAP=VIRTUAL>",
	  "$image</TEXTAREA>";
	if ($UserUploadDir && !(-s "$adverts_dir/$INPUT{'reviewone'}.txt")) {
		print "<BR><SMALL><EM>(You may leave this blank; once your account has been created, ";
		print "you'll have the option of uploading a banner from your computer. ";
		print "Just return to the edit screen to do so.)</EM></SMALL>";
	}
	print "</FONT></SMALL></TD></TR>\n";
	if (%nonssi_cgis) {
		print "<TR><TD VALIGN=TOP><SMALL><FONT $fontspec>Zone(s):</FONT></SMALL></TD><TD><SMALL><FONT $fontspec>";
		foreach $setzone (sort (keys %nonssi_cgis)) {
			print "<INPUT TYPE=CHECKBOX NAME=zone ";
			print "VALUE=\"$setzone\"";
			if ($zone =~ /$setzone/) {
				print " CHECKED";
			}
			print ">$setzone\n<BR>";
		}
		print "<SMALL><EM>(Select target categories of pages ";
		print "on which this banner should be displayed.)</EM></SMALL>";
		print "</FONT></SMALL></TD></TR>\n";
		print "<TR><TD></TD><TD><SMALL><FONT FACE=\"Courier\"><SELECT NAME=displayzone>";
		foreach $setzone (sort (keys %nonssi_cgis)) {
			print "<OPTION";
			if ($displayzone eq $setzone) {
				print " SELECTED";
			}
			print ">$setzone";
		}
		print "</SELECT></FONT><FONT $fontspec>";
		print "<BR><SMALL><EM>(Select the category of banners ";
		print "to be displayed on your own pages.)</EM></SMALL>";
		print "</FONT></SMALL></TD></TR>\n";
	}
	print "<TR><TD COLSPAN=2><HR WIDTH=50%></TD></TR>\n",
	  "</TABLE>\n",
	  "<P><INPUT TYPE=HIDDEN NAME=editad ",
	  "VALUE=\"$INPUT{'reviewone'}\">\n",
	  "<INPUT TYPE=HIDDEN NAME=password ",
	  "VALUE=$INPUT{'password'}>\n",
	  "<INPUT TYPE=HIDDEN NAME=pass VALUE=\"$pass\">\n";
	if ($AllowUserEdit && $INPUT{'newuser'}) {
		print "<INPUT TYPE=HIDDEN NAME=newuser ";
		print "VALUE=$INPUT{'newuser'}>\n";
	}
	if ($cryptword) {
		print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
	}
	print "<P><INPUT TYPE=SUBMIT NAME=editfinal ";
	print "VALUE=\"Add/Edit Account\">\n";
	if (-s "$adverts_dir/$INPUT{'reviewone'}.txt") {
		print "<P><INPUT TYPE=SUBMIT NAME=del ";
		print "VALUE=\"Delete Account\"> ";
		print "<INPUT TYPE=HIDDEN NAME=delad ";
		print "VALUE=\"$INPUT{'reviewone'}\">\n";
	}
	print "</CENTER></FORM>\n";
	print "<P><HR><P>If you'd like to change your account password, ";
	print "simply enter it below.\n";
	print "<FORM METHOD=POST ACTION=$admin_cgi>\n",
	  "<CENTER><P>New Password: <FONT FACE=\"Courier\"><INPUT TYPE=TEXT ",
	  "NAME=pass VALUE=\"$pass\" SIZE=50></FONT>\n",
	  "<P><INPUT TYPE=HIDDEN NAME=reviewone ",
	  "VALUE=\"$INPUT{'reviewone'}\">\n",
	  "<INPUT TYPE=HIDDEN NAME=password ",
	  "VALUE=$INPUT{'password'}>\n";
	if ($cryptword) {
		print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
	}
	print "<P><INPUT TYPE=SUBMIT NAME=newuserpassword ";
	print "VALUE=\"Change Password\"></CENTER></FORM>\n";
	if ($UserUploadDir && (-s "$adverts_dir/$INPUT{'reviewone'}.txt")) {
		print "<P><HR><P>If you'd like to upload a new banner for your account, ";
		print "you may do so from here. <EM>(Note that you must be using either ";
		print "Netscape Navigator version 2 or higher, or Microsoft Internet Explorer ";
		print "version 4 or higher.)</EM>\n";
		print "<FORM ENCTYPE=\"multipart/form-data\" METHOD=POST ACTION=$admin_cgi>\n",
		  "<CENTER><P>File to Upload: <FONT FACE=\"Courier\"><INPUT TYPE=FILE NAME=\"banner\" SIZE=35></FONT>",
		  "<P><INPUT TYPE=HIDDEN NAME=reviewone ",
		  "VALUE=\"$INPUT{'reviewone'}\">\n",
		  "<INPUT TYPE=HIDDEN NAME=password ",
		  "VALUE=$INPUT{'password'}>\n";
		if ($cryptword) {
			print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
		}
		print "<P><INPUT TYPE=SUBMIT NAME=uploadbanner ";
		print "VALUE=\"Upload Banner\"></CENTER></FORM>\n";
	}
	&Footer;
}

sub NewUserPassword {
	$INPUT{'reviewone'} =~ s/[^\w_-]//g;
	$INPUT{'reviewone'} =~ tr/A-Z/a-z/;
	if (-s "$adverts_dir/$INPUT{'reviewone'}.txt") {
		open (DISPLAY, "<$adverts_dir/$INPUT{'reviewone'}.txt");
		@lines = <DISPLAY>;
		close (DISPLAY);
		foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
		($pass) = @lines[8];
		unless ($INPUT{'password'} eq $pass) {
			&ConfirmAdminPassword(2);
		}
	}
	else {
		&Header("WebAdverts Error!","Invalid Account Name!");
		print "<P ALIGN=CENTER>There is no account with the name ";
		print "<STRONG>&quot;$INPUT{'reviewone'}&quot;</STRONG> ";
		print "on the list!\n";
		print "<P ALIGN=CENTER>(Note that account names ";
		print "<EM>are</EM> case sensitive!)\n";
		&Footer;
	}
	@lines[8] = $INPUT{'pass'};
	$INPUT{'password'} = $INPUT{'pass'};
	&LockOpen (DISPLAY, "$INPUT{'reviewone'}.txt");
	seek (DISPLAY,0,0);
	foreach $key (0..20) {
		print DISPLAY "$lines[$key]\n";
	}
	truncate (DISPLAY,tell(DISPLAY));
	&LockClose (DISPLAY, "$INPUT{'reviewone'}.txt");
	&reviewone;
}

sub UploadBanner {
	$INPUT{'reviewone'} =~ s/[^\w_-]//g;
	$INPUT{'reviewone'} =~ tr/A-Z/a-z/;
	if (-s "$adverts_dir/$INPUT{'reviewone'}.txt") {
		open (DISPLAY, "<$adverts_dir/$INPUT{'reviewone'}.txt");
		@lines = <DISPLAY>;
		close (DISPLAY);
		foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
		($image,$pass) = @lines[4,8];
		unless ($INPUT{'password'} eq $pass) {
			&ConfirmAdminPassword(2);
		}
	}
	else {
		&Header("WebAdverts Error!","Invalid Account Name!");
		print "<P ALIGN=CENTER>There is no account with the name ";
		print "<STRONG>&quot;$INPUT{'reviewone'}&quot;</STRONG> ";
		print "on the list!\n";
		print "<P ALIGN=CENTER>(Note that account names ";
		print "<EM>are</EM> case sensitive!)\n";
		&Footer;
	}
	if ($BannerType eq "GIF") { $bannername = "$INPUT{'reviewone'}.gif"; }
	elsif ($BannerType eq "JPG") { $bannername = "$INPUT{'reviewone'}.jpg"; }
	else {
		&Header("WebAdverts Error!","Invalid Banner Format!");
		print "<P ALIGN=CENTER>Your banner must be in <STRONG>GIF</STRONG> (.gif) ";
		print "or <STRONG>JPEG</STRONG> (.jpg or .jpeg) format!\n";
		&Footer;
	}
	if (length($INPUT{'BannerFile'}) > ($MaxBannerSize*1024)) {
		&Header("WebAdverts Error!","Banner Too Large!");
		print "<P ALIGN=CENTER>Your banner is too large! Its file size ";
		print "must be no more than <STRONG>$MaxBannerSize</STRONG> ";
		print "kilobytes.<BR>(The file you attempted to upload was ";
		print int((length($INPUT{'BannerFile'})/1024)+.5)," kilobytes.)\n";
		&Footer;
	}	
	unless (open (BANNER,">$UserUploadDir/$bannername")) {
		&Header("WebAdverts Error!","Unable to Open File!");
		print "<P ALIGN=CENTER>The script was unable to open a file ";
		print "to save your banner.<BR>(This most likely indicates ";
		print "a permissions error on the upload directory.)\n";
		&Footer;
	}
	print BANNER $INPUT{'BannerFile'};
	close (BANNER);
	$image = "$UserUploadURL/$bannername";
	&LockOpen (DISPLAY, "$INPUT{'reviewone'}.txt");
	seek (DISPLAY,0,0);
	$lines[4] = $image;
	foreach $key (0..20) {
		print DISPLAY "$lines[$key]\n";
	}
	truncate (DISPLAY,tell(DISPLAY));
	&LockClose (DISPLAY, "$INPUT{'reviewone'}.txt");
	$PresenceCheck = 0;
	unless ($cryptword || !($RequireAdminApproval)) {
		&LockOpen (COUNT, "adlist.txt");
		@lines = <COUNT>;
		foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
		seek(COUNT, 0, 0);
		foreach $line (@lines) {
			if ($line eq $INPUT{'reviewone'}) { $PresenceCheck = 1; }
			unless (($line eq $INPUT{'reviewone'}) || (length($line) < 1)) {
				print COUNT "$line\n";
			}
		}
		truncate (COUNT, tell(COUNT));
		&LockClose (COUNT, "adlist.txt");
	}
	if ($PresenceCheck) {
		$PresenceCheck = 0;
		&LockOpen (COUNT, "adnew.txt");
		@lines = <COUNT>;
		foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
		seek(COUNT, 0, 0);
		foreach $line (@lines) {
			if ($line eq $INPUT{'reviewone'}) { $PresenceCheck = 1; }
			unless (($line eq $INPUT{'reviewone'}) || (length($line) < 1)) {
				print COUNT "$line\n";
			}
		}
		unless ($PresenceCheck) {
			print COUNT "$INPUT{'reviewone'}\n";
			$editad = $INPUT{'reviewone'};
			&SendMail($email_address,"admin");
		}
		truncate (COUNT, tell(COUNT));
		&LockClose (COUNT, "adnew.txt");
	}
	&reviewone;
}

sub CheckName {
	local($namecheck) = @_;
	if (($namecheck eq "adcount") || ($namecheck eq "adlist")
	  || ($namecheck eq "adnew") || ($namecheck eq "adpassword")
	  || ($namecheck eq "groups") || ($namecheck eq "register")
	  || ($namecheck eq "welcome") || ($namecheck eq "reject")
	  || ($namecheck eq "adminlog") || ($namecheck =~ /ads_/)) {
		&Header("WebAdverts Error!","Illegal Account Name!");
		print "<P>The account name you selected isn't allowed. ";
		print "Please go back and pick another one!\n";
		&Footer;
	}
}

sub groupedit {
	&ConfirmAdminPassword(1);
	$INPUT{'editgroup'} =~ s/[^\w_-]//g;
	$INPUT{'editgroup'} =~ tr/A-Z/a-z/;
	&CheckName($INPUT{'editgroup'});
	if (-s "$adverts_dir/$INPUT{'editgroup'}.grp") {
		open (DISPLAY, "<$adverts_dir/$INPUT{'editgroup'}.grp");
		@lines = <DISPLAY>;
		close (DISPLAY);
		$grouppassword = $lines[0];
		$adverts = join(' ',@lines);
	}
	&Header("WebAdverts","Add/Edit/Delete Group");
	print "<FORM METHOD=POST ACTION=$admin_cgi>\n";
	print "<P><CENTER><BIG><STRONG>Info for the ";
	print "<EM>$INPUT{'editgroup'}</EM> Group:";
	print "</STRONG></BIG>\n";
	print "<P>Select the adverts to be included in this group:\n";
	open (COUNT, "<$adverts_dir/adlist.txt");
	@lines = <COUNT>;
	close (COUNT);
	foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
	@sortedlines = sort (@lines);
	$size = @lines;
	if ($size > 10) { $size = 10; }
	print "<P><FONT FACE=\"Courier\"><SELECT NAME=groupadverts MULTIPLE ";
	print "SIZE=$size>\n";
	foreach $advertiser (@sortedlines) {
		next if (length($advertiser) < 1);
		print "<OPTION VALUE=\"$advertiser\"";
		if ($adverts && ($adverts =~ $advertiser)) {
			print " SELECTED";
		}
		print "> $advertiser ";
	}
	print "</SELECT></FONT>\n";
	print "<P>Password: <FONT FACE=\"Courier\"><INPUT TYPE=TEXT ";
	print "NAME=pass VALUE=\"$grouppassword\" SIZE=25></FONT>\n";
	print "<P><INPUT TYPE=HIDDEN NAME=editgroup ";
	print "VALUE=\"$INPUT{'editgroup'}\">\n";
	print "<INPUT TYPE=HIDDEN NAME=password ";
	print "VALUE=$INPUT{'password'}>\n";
	print "<INPUT TYPE=SUBMIT NAME=editgroupfinal ";
	print "VALUE=\"Add/Edit Group\">\n";
	if (-s "$adverts_dir/$INPUT{'editgroup'}.grp") {
		print "<P><INPUT TYPE=SUBMIT NAME=delgroup ";
		print "VALUE=\"Delete Group\"> ";
		print "<INPUT TYPE=HIDDEN NAME=delgroupname ";
		print "VALUE=\"$INPUT{'editgroup'}\">\n";
	}
	print "</CENTER></FORM>\n";
	&Footer;
}

sub del {
	$INPUT{'delad'} =~ s/[^\w_-]//g;
	$INPUT{'delad'} =~ tr/A-Z/a-z/;
	&CheckName($INPUT{'delad'});
	unless (-s "$adverts_dir/$INPUT{'delad'}.txt") {
		&Header("WebAdverts Error!","Invalid Account Name!");
		print "<P ALIGN=CENTER>There is no account with the name ";
		print "<STRONG>&quot;$INPUT{'delad'}&quot;</STRONG> ";
		print "on the list!\n";
		print "<P ALIGN=CENTER>(Note that account names ";
		print "<EM>are</EM> case sensitive!)\n";
		&Footer;
	}
	$INPUT{'advert'} = $INPUT{'delad'};
	&ConfirmUserPassword;
	&Header("WebAdverts","&quot;Delete&quot; Request Confirmation");
	print "<FORM METHOD=POST ACTION=$admin_cgi>\n";
	print "<INPUT TYPE=HIDDEN NAME=password ";
	print "VALUE=$INPUT{'password'}>\n";
	print "<P><CENTER>Are you <EM>sure</EM> you want to delete the ";
	print "<STRONG>$INPUT{'delad'}</STRONG> account?\n";
	print "<INPUT TYPE=HIDDEN NAME=delad VALUE=$INPUT{'delad'}>\n";
	if ($INPUT{'rejectionletter'}) {
		print "<INPUT TYPE=HIDDEN NAME=rejectionletter ";
		print "VALUE=\"$INPUT{'rejectionletter'}\">\n";
	}
	if ($cryptword) {
		print "<INPUT TYPE=HIDDEN NAME=admincheck VALUE=1>\n";
	}
	print "<INPUT TYPE=SUBMIT NAME=delfinal VALUE=\"Yes\">\n";
	print "</CENTER></FORM>\n";
	&Footer;
}

sub delgroup {
	$INPUT{'delgroupname'} =~ s/[^\w_-]//g;
	$INPUT{'delgroupname'} =~ tr/A-Z/a-z/;
	&CheckName($INPUT{'delgroupname'});
	unless (-s "$adverts_dir/$INPUT{'delgroupname'}.grp") {
		&Header("WebAdverts Error!","Invalid Group Name!");
		print "<P ALIGN=CENTER>There is no group ";
		print "on the list defined with the name <STRONG>";
		print "&quot;$INPUT{'delgroupname'}&quot;</STRONG>!\n";
		print "<P ALIGN=CENTER>(Note that group names ";
		print "<EM>are</EM> case sensitive!)\n";
		&Footer;
	}
	&ConfirmAdminPassword(1);
	&Header("WebAdverts","&quot;Delete&quot; Request Confirmation");
	print "<FORM METHOD=POST ACTION=$admin_cgi>\n";
	print "<P><CENTER>Are you <EM>sure</EM> you want to delete the ";
	print "<STRONG>$INPUT{'delgroupname'}</STRONG> group? ";
	print "<INPUT TYPE=HIDDEN NAME=delgroupname ";
	print "VALUE=$INPUT{'delgroupname'}>\n";
	print "<INPUT TYPE=HIDDEN NAME=password ";
	print "VALUE=$INPUT{'password'}>\n";
	print "<INPUT TYPE=SUBMIT NAME=delgroupfinal VALUE=\"Yes\">\n";
	print "</CENTER></FORM>\n";
	print "<P>(Please note that deleting the group will ";
	print "<EM>not</EM> delete or otherwise affect the adverts ";
	print "themselves. Only the ability to view all their stats ";
	print "on a single page will be gone!)\n";
	&Footer;
}

sub newpass {
	unless ($INPUT{'passad'} && ($INPUT{'passad'} eq $INPUT{'passad2'})) {
		&Header("WebAdverts Error!","Password Mismatch!");
		print "<P ALIGN=CENTER>Your administrative password was ";
		print "not set, as the two entries were different!\n";
		&Footer;
	}
	open (PASSWORD, "<$adverts_dir/adpassword.txt");
	$password = <PASSWORD>;
	close (PASSWORD);
	chop ($password) if ($password =~ /\n$/);
	if ($password) {
		if ($INPUT{'password'}) {
			$newpassword = crypt($INPUT{'password'}, "aa");
		}
		else {
			&Header("WebAdverts Error!","No Password!");
			print "<P ALIGN=CENTER>You must ";
			print "enter a password!\n";
			&Footer;
		}
		unless ($newpassword eq $password) {
			&Header("WebAdverts Error!","Invalid Password!");
			print "<P ALIGN=CENTER>";
			print "The password you entered is incorrect!\n";
			&Footer;
		}
	}
	$newpassword = crypt($INPUT{'passad'}, "aa");
	&LockOpen (PASSWORD, "adpassword.txt");
	seek (PASSWORD,0,0);
	print PASSWORD "$newpassword";
	truncate (PASSWORD,tell(PASSWORD));
	&LockClose (PASSWORD,"adpassword.txt");
	&Header("WebAdverts","Password Set");
	print "<P ALIGN=CENTER>Your administrative password ";
	print "has been set.\n";
	$INPUT{'password'} = $INPUT{'passad'};
	&LinkBack;
	&Footer;
}

sub resetcount {
	&ConfirmAdminPassword(1);
	&LockOpen (COUNT, "adcount.txt");
	seek(COUNT, 0, 0);
	print COUNT "1\n";
	print COUNT "0\n";
	print COUNT "$time\n";
	truncate (COUNT, tell(COUNT));
	&LockClose (COUNT, "adcount.txt");
	if ($AdminDisplaySetup) { &defineview; }
	else {
		$INPUT{'whichtype'} = "pending established groups";
		$INPUT{'whichtime'} = "active expired disabled";
		$INPUT{'whichzone'} = "";
		&reviewall;
	}
}

sub editfinal {
	$INPUT{'editad'} =~ s/[^\w_-]//g;
	$INPUT{'editad'} =~ tr/A-Z/a-z/;
	$INPUT{'advert'} = $INPUT{'editad'};
	&CheckName($INPUT{'advert'});
	unless ($AllowUserEdit && $INPUT{'newuser'}) {
		&ConfirmUserPassword;
	}
	$editad = $INPUT{'editad'};
	if (-s "$adverts_dir/$editad.txt") {
		open (DISPLAY, "<$adverts_dir/$editad.txt");
		@lines = <DISPLAY>;
		close (DISPLAY);
		foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
		if ($cryptword) {
			($shown,$visits,$start,$displaycount,$clicksfrom)
			  = @lines[1,2,10,16,20];
			($other,$displaycount) = split (/\|/, $displaycount);
		}
		else {
			($max,$shown,$visits,$dmy,$dmy,$height,$width,
			  $alt,$dmy,$text,$start,$weight,$zone,
			  $border,$target,$raw,$displayratio,
			  $dmy,$dmy,$displayzone,$clicksfrom) = @lines;
			($max,$maxtype) = split (/\|/, $max);
			($text,$texttype) = split (/\|/, $text);
			($displayratio,$displaycount)
			  = split (/\|/, $displayratio);
		}
	}
	elsif (!($cryptword)) {
		$maxtype = "E";
		$texttype = "B";
		$displayratio = $DefaultDisplayRatio;
		$weight = $DefaultWeight;
		$border = $DefaultBorder;
	}
	$INPUT{'email'} =~ s/\s//g;
	unless ($INPUT{'email'} =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|,|;/
	  || $INPUT{'email'} !~
	  /^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})(\]?)$/)
	  {
		$email = "$INPUT{'email'}";
	}
	$INPUT{'url'} =~ s/\s//g;
	unless ($INPUT{'url'} =~ /\*|(\.\.)|(^\.)|(\/\/\.)/ ||
	  $INPUT{'url'} !~ /(.*\:\/\/.*\..*|mailto:.*@.*)/) {
		$url = $INPUT{'url'};
	}
	@image = split (/\cM|\n/,$INPUT{'image'});
	foreach $fauximage (@image) {
		$fauximage =~ s/\s//g;
		unless ($fauximage =~ /\*|(\.\.)|(^\.)|(\/\/\.)/ ||
		  $fauximage !~ /.*\:\/\/.*\..*/) {
			$image = $image.$fauximage."|";
		}
	}
	chop $image;
	$pass = $INPUT{'pass'};
	if ($cryptword) {
		$displayratio = $INPUT{'displayratio'};
		$weight = int($INPUT{'weight'});
	}
	if ($INPUT{'zone'}) {
		$zone = $INPUT{'zone'};
		$zone =~ s/^\s+//;
		$zone =~ s/\s+$//;
		$zone =~ s/\s+/ /g;
	}
	if ($INPUT{'displayzone'}) {
		$displayzone = $INPUT{'displayzone'};
	}
	if ($cryptword) {
		if ($INPUT{'purchtype'} eq "D") {
			$INPUT{'purch'} = $time + ($INPUT{'purch'}*86400);
		}
		$INPUT{'purch'} =~ s/[^\d]//g;
		$max = $INPUT{'purch'};
		$maxtype = $INPUT{'purchtype'};
		if ($INPUT{'startday'}) {
			$INPUT{'startday'}
			  = $time + ($INPUT{'startday'}*86400);
			$start = $INPUT{'startday'}
		}
		elsif ($start > $time) {
			$start = $time;
		}
		$height = int($INPUT{'height'});
		$width = int($INPUT{'width'});
		$alt = $INPUT{'alt'};
		$INPUT{'text'} =~ s/^\s+//;
		$INPUT{'text'} =~ s/\s+$//;
		$INPUT{'text'} =~ s/\s+/ /g;
		$text = $INPUT{'text'};
		$texttype = $INPUT{'texttype'};
		$border = int($INPUT{'border'});
		$target = $INPUT{'target'};
		$INPUT{'raw'} =~ s/(\cM|\n)+/<NLB>/g;
		$raw = $INPUT{'raw'};
	}
	unless ($pass) {
		&Header("WebAdverts Error!","Incomplete Entry!");
		print "<P>You didn't provide all of the necessary ";
		print "information! You must at <EM>least</EM> ";
		print "include a password!\n";
		&Footer;
	}
	if ((($maxtype eq "C") || ($maxtype eq "D")) && ($displayratio)) {
		&Header("WebAdverts Error!","Invalid Entry!");
		print "<P>You've indicated that this account is to earn exposures by ";
		print "showing other banners, but have also indicated that it is to ";
		print "expire based on date or click-thrus.  These two designations are ";
		print "mutually incompatible!  Display ratios may only be set for ";
		print "accounts which are defined as non-expiring, or for which a set ";
		print "number of &quot;bonus&quot; exposures have been defined.\n";
		&Footer;
	}
	$PresenceCheck = 0;
	if (-s "$adverts_dir/adnew.txt") {
		&LockOpen (COUNT, "adnew.txt");
		@lines = <COUNT>;
		foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
		seek(COUNT, 0, 0);
		foreach $line (@lines) {
			if ($line eq $editad) { $PresenceCheck = 1; }
			unless (($line eq $editad) || (length($line) < 1)) {
				print COUNT "$line\n";
			}
		}
		truncate (COUNT, tell(COUNT));
		&LockClose (COUNT, "adnew.txt");
	}
	if (-s "$adverts_dir/adlist.txt") {
		&LockOpen (COUNT, "adlist.txt");
		@lines = <COUNT>;
		foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
		seek(COUNT, 0, 0);
		foreach $line (@lines) {
			if ($line eq $editad) { $PresenceCheck = 1; }
			unless (($line eq $editad) || (length($line) < 1)) {
				print COUNT "$line\n";
			}
		}
		truncate (COUNT, tell(COUNT));
		&LockClose (COUNT, "adlist.txt");
	}
	if ($INPUT{'resetadvert'}
	  || (!$PresenceCheck && !$shown)) {
		$shown = 0;
		$visits = 0;
		unless ($start > $time) { $start = $time; }
		$displaycount = 0;
		$clicksfrom = 0;
		unlink ("$adverts_dir/$editad.log");
		unlink ("$adverts_dir/$editad.log.bak");
		unlink ("$adverts_dir/$editad.ips");
	}
	if ($maxtype eq "N") { $max = 0; }
	&LockOpen (DISPLAY, "$editad.txt");
	seek (DISPLAY,0,0);
	print DISPLAY "$max|$maxtype\n";
	print DISPLAY "$shown\n";
	print DISPLAY "$visits\n";
	print DISPLAY "$url\n";
	print DISPLAY "$image\n";
	print DISPLAY "$height\n";
	print DISPLAY "$width\n";
	print DISPLAY "$alt\n";
	print DISPLAY "$pass\n";
	print DISPLAY "$text|$texttype\n";
	print DISPLAY "$start\n";
	print DISPLAY "$weight\n";
	print DISPLAY " $zone \n";
	print DISPLAY "$border\n";
	print DISPLAY "$target\n";
	print DISPLAY "$raw\n";
	print DISPLAY "$displayratio|$displaycount\n";
	print DISPLAY "$INPUT{'username'}\n";
	print DISPLAY "$email\n";
	print DISPLAY "$displayzone\n";
	print DISPLAY "$clicksfrom\n";
	truncate (DISPLAY,tell(DISPLAY));
	&LockClose (DISPLAY, "editad.txt");
	if ($cryptword || !($RequireAdminApproval)) {
		&LockOpen (COUNT, "adlist.txt");
		@adlist = <COUNT>;
		seek (COUNT,0,0);
		foreach $adlist (@adlist) {
			print COUNT "$adlist";
		}
		print COUNT "$editad\n";
		truncate (COUNT,tell(COUNT));
		&LockClose (COUNT, "adlist.txt");
	}
	else {
		&LockOpen (COUNT, "adnew.txt");
		@adnew = <COUNT>;
		seek (COUNT,0,0);
		foreach $adnew (@adnew) {
			print COUNT "$adnew";
		}
		print COUNT "$editad\n";
		truncate (COUNT,tell(COUNT));
		&LockClose (COUNT, "adnew.txt");
		&SendMail($email_address,"admin");
	}
	$INPUT{'reviewone'} = $editad;
	&reviewone;
}

sub editgroupfinal {
	&ConfirmAdminPassword(1);
	$INPUT{'editgroup'} =~ s/[^\w_-]//g;
	$INPUT{'editgroup'} =~ tr/A-Z/a-z/;
	&CheckName($INPUT{'editgroup'});
	$editgroup = $INPUT{'editgroup'};
	$pass = $INPUT{'pass'};
	@groupadverts = split(' ',$INPUT{'groupadverts'});
	unless ($pass && (@groupadverts > 0)) {
		&Header("WebAdverts Error!","Incomplete Form!");
		print "<P>You didn't provide all of the necessary ";
		print "information to allow creation ";
		print "of the <STRONG>$editgroup</STRONG> ";
		print "group!\n";
		&Footer;
	}
	&LockOpen (GROUP, "$editgroup.grp");
	seek (GROUP,0,0);
	print GROUP "$pass\n";
	foreach $advert (@groupadverts) {
		print GROUP "$advert\n";
	}
	truncate (GROUP,tell(GROUP));
	&LockClose (GROUP,"$editgroup.grp");
	$PresenceCheck = 0;
	if (-s "$adverts_dir/groups.txt") {
		open (COUNT, "<$adverts_dir/groups.txt");
		@lines = <COUNT>;
		close (COUNT);
	}
	foreach $line (@lines) {
		chop ($line) if ($line =~ /\n$/);
		if ($line eq $editgroup) { $PresenceCheck = 1; }
	}
	unless ($PresenceCheck) {
		&LockOpen (COUNT, "groups.txt");
		@groups = <COUNT>;
		seek (COUNT,0,0);
		foreach $group (@groups) {
			print COUNT "$group";
		}
		print COUNT "$editgroup\n";
		truncate (COUNT,tell(COUNT));
		&LockClose (COUNT,"groups.txt");
	}
	&Header("WebAdverts","Group Updated!");
	print "<P ALIGN=CENTER>";
	print "The <STRONG>$editgroup</STRONG> group now includes ";
	print "the following adverts:\n";
	print "<P ALIGN=CENTER><STRONG>";
	foreach $advert (@groupadverts) {
		chop $advert if ($advert =~ /\n$/);
		print "$advert ";
	}
	print "</STRONG>\n";
	&LinkBack;
	&Footer;
}

sub delfinal {
	$INPUT{'delad'} =~ s/[^\w_-]//g;
	$INPUT{'delad'} =~ tr/A-Z/a-z/;
	$INPUT{'advert'} = $INPUT{'delad'};
	&CheckName($INPUT{'advert'});
	&ConfirmUserPassword;
	$delad = $INPUT{'delad'};
	unlink ("$adverts_dir/$delad.txt");
	unlink ("$adverts_dir/$delad.txt.bak");
	unlink ("$adverts_dir/$delad.log");
	unlink ("$adverts_dir/$delad.log.bak");
	unlink ("$adverts_dir/$delad.ips");
	if ($UserUploadDir) {
		unlink ("$UserUploadDir/$delad.gif");
		unlink ("$UserUploadDir/$delad.jpg");
	}
	if (-s "$adverts_dir/adlist.txt") {
		&LockOpen (COUNT, "adlist.txt");
		@lines = <COUNT>;
		foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
		seek (COUNT,0,0);
		foreach $line (@lines) {
			unless (($line eq $delad) || (length($line) < 1)) {
				print COUNT "$line\n";
			}
		}
		truncate (COUNT, tell(COUNT));
		&LockClose (COUNT,"adlist.txt");
	}
	if (-s "$adverts_dir/adnew.txt") {
		&LockOpen (COUNT, "adnew.txt");
		@lines = <COUNT>;
		foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
		seek (COUNT,0,0);
		foreach $line (@lines) {
			unless (($line eq $delad) || (length($line) < 1)) {
				print COUNT "$line\n";
			}
		}
		truncate (COUNT, tell(COUNT));
		&LockClose (COUNT,"adnew.txt");
	}
	if ($INPUT{'rejectionletter'}) {
		open (REJECT, "<$adverts_dir/reject.txt");
		$body = "";
		while (defined($line = <REJECT>)) {
			$body .= $line;
		}
		close (REJECT);
		&SendMail($INPUT{'rejectionletter'},"reject");
	}
	if ($cryptword) {
		if ($AdminDisplaySetup) { &defineview; }
		else {
			$INPUT{'whichtype'} = "pending established groups";
			$INPUT{'whichtime'} = "active expired disabled";
			$INPUT{'whichzone'} = "";
			&reviewall;
		}
	}
	&userintro;
}

sub delgroupfinal {
	&ConfirmAdminPassword(1);
	$INPUT{'delgroupname'} =~ s/[^\w_-]//g;
	$INPUT{'delgroupname'} =~ tr/A-Z/a-z/;
	&CheckName($INPUT{'delgroupname'});
	$delgroup = $INPUT{'delgroupname'};
	unlink ("$adverts_dir/$delgroup.grp");
	if (-s "$adverts_dir/groups.txt") {
		&LockOpen (COUNT, "groups.txt");
		@lines = <COUNT>;
		foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
		seek (COUNT,0,0);
		foreach $line (@lines) {
			unless (($line eq $delgroup) || (length($line) < 1)) {
				print COUNT "$line\n";
			}
		}
		truncate (COUNT, tell(COUNT));
		&LockClose (COUNT,"groups.txt");
	}
	if ($AdminDisplaySetup) { &defineview; }
	else {
		$INPUT{'whichtype'} = "pending established groups";
		$INPUT{'whichtime'} = "active expired disabled";
		$INPUT{'whichzone'} = "";
		&reviewall;
	}
}

sub LinkBack {
	print "<P><CENTER>\n";
	print "<FORM METHOD=POST ACTION=$admin_cgi>\n";
	print "<INPUT TYPE=HIDDEN NAME=password ";
	print "VALUE=$INPUT{'password'}>\n";
	print "<INPUT TYPE=HIDDEN NAME=reviewone ";
	print "VALUE=\"Define View\">\n";
	print "<INPUT TYPE=SUBMIT ";
	print "VALUE=\"Reload Account Index\">\n";
	print "</FORM></CENTER>\n";
}

sub Header {
	local($title,$header) = @_;
	if ($ExchangeName) {
		$title =~ s/WebAdverts/$ExchangeName/g;
		$header =~ s/WebAdverts/$ExchangeName/g;
	}
	print "<HTML><HEAD><TITLE>$title</TITLE>\n";
	if ($MetaFile) {
		open (HEADLN,"$MetaFile");
		@headln = <HEADLN>;
		close (HEADLN);
		foreach $line (@headln) {
			print "$line";
		}
	}
	print "</HEAD><BODY $bodyspec><SMALL><FONT $fontspec>\n";
	if ($header_file) {
		open (HEADER,"<$header_file");
		@header = <HEADER>;
		close (HEADER);
		foreach $line (@header) {
			if ($line =~ /<!--#include\s+(virtual|file)\s*=\s*"*([^"\s]*)"*\s*-->/i) {
				$SSIFile = $SSIRootDir.$2;
				open (SSIFILE,"<$SSIFile");
				while (<SSIFILE>) { print "$_"; }
				close (SSIFILE);
			}
			else { print "$line"; }
		}
	}
	print "<P><HR><H2 ALIGN=CENTER>$header</H2><P><HR>\n";
}

sub Footer {
	local($adminlog) = @_;
	if ($LogAdminAccesses && (length($adminlog)>7)) {
		($min,$hour,$mday,$mon,$year) = (localtime($time))[1,2,3,4,5];
		$mon++;
		if ($mon<10) { $mon = "0".$mon; }
		if ($mday<10) { $mday = "0".$mday; }
		if ($year>99) { $year = $year-100; }
		if ($year<10) { $year = "0".$year; }
		if ($hour<10) { $hour = "0".$hour; }
		if ($min<10) { $min = "0".$min; }
		if (length($adminlog)>25) { $adminlog = substr($adminlog,0,25); }
		open (ADMINLOG,">>$adverts_dir/adminlog.txt");
		print ADMINLOG "$mon/$mday/$year $hour:$min  ";
		printf ADMINLOG "%-25s",$adminlog;
		print ADMINLOG "  $ENV{'REMOTE_ADDR'}";
		if ($ENV{'REMOTE_HOST'} ne $ENV{'REMOTE_ADDR'}) {
			print ADMINLOG " ($ENV{'REMOTE_HOST'})";
		}
		print ADMINLOG "\n";
		close (ADMINLOG);
	}
	print "<P ALIGN=CENTER><SMALL><EM>Maintained ";
	unless ($admin_name) { $admin_name = $email_address; }
	if ($admin_name) {
		print "by ";
		if ($email_address) { print "<A HREF=\"mailto:$email_address\">"; }
		print "$admin_name";
		if ($email_address) { print "</A>"; }
		print " ";
	}
	print "with <STRONG>";
	print "<A HREF=\"http://awsd.com/scripts/webadverts/\">";
	print "WebAdverts $version</A></STRONG>.</EM></SMALL>\n";
	if ($footer_file) {
		print "<P><HR>\n";
		open (FOOTER,"<$footer_file");
		@footer = <FOOTER>;
		close (FOOTER);
		foreach $line (@footer) {
			if ($line =~ /<!--#include\s+(virtual|file)\s*=\s*"*([^"\s]*)"*\s*-->/i) {
				$SSIFile = $SSIRootDir.$2;
				open (SSIFILE,"<$SSIFile");
				while (<SSIFILE>) { print "$_"; }
				close (SSIFILE);
			}
			else { print "$line"; }
		}
	}
	print "</FONT></SMALL></BODY></HTML>\n";
	unless ($UseLocking) { &MasterLockClose; }
	reset 'A-Za-z';
	exit;
}

sub register {
	unless ($INPUT{'register'} eq "frtytw") {
		&Header("WebAdverts Error!","Incorrect Code!");
		print "<P ALIGN=CENTER>Sorry, but the registration code ";
		print "you entered is incorrect!\n";
		&Footer;
	}
	open (REGISTER, ">$adverts_dir/register.txt");
	print REGISTER "frtytw";
	close (REGISTER);
	&Header("WebAdverts","Thanks For Registering!");
	print "<P ALIGN=CENTER>Your support is appreciated!\n";
	&Footer;
}

sub reginfo {
	&Header("WebAdverts","Registration Information");
	print "<P>WebAdverts is distributed as shareware. While you ",
	  "are free to modify and use it as you see fit, any usage ",
	  "should be registered. The registration fee is just \$50 ",
	  "(US). Payment should be sent via check or money order ",
	  "to <STRONG>Darryl C. Burgdorf, Affordable Web Space ",
	  "Design, 3524 Pacific Street, Omaha NE 68105</STRONG>.\n",
	  "<P>(If you happen to live in a country other than the ",
	  "United States, you can write a check in your local ",
	  "currency for the equivalent of \$57.50. That will cover ",
	  "the \$50 registration fee and the \$7.50 ",
	  "service fee which my bank charges. Please do ",
	  "<STRONG><EM>not</EM></STRONG> write me a check ",
	  "in US funds drawn on a non-US bank; the service charge ",
	  "for those can be anywhere from \$10 to \$25!)\n",
	  "<P>Thank you for your support!\n",
	  "<P><CENTER>\n",
	  "<FORM METHOD=POST ACTION=$admin_cgi>\n",
	  "<INPUT TYPE=SUBMIT VALUE=\"Enter Registration Code:\">\n",
	  "<FONT FACE=\"Courier\"><INPUT TYPE=TEXT NAME=register SIZE=10></FONT>\n",
	  "</FORM></CENTER>\n";
	&Footer;
}

sub date_to_count {
	($perp_mon,$perp_day,$perp_year) = @_;
	%day_counts =
	  (1,0,2,31,3,59,4,90,5,120,6,151,7,181,
	  8,212,9,243,10,273,11,304,12,334);
	$perp_days = (($perp_year-93)*365)+(int(($perp_year-93)/4));
	$perp_days = $perp_days + $day_counts{$perp_mon};
	if ((int(($perp_year-92)/4) eq (($perp_year-92)/4))
	  && ($perp_mon>2)) {
		$perp_days++;
	}
	$perp_days = $perp_days + $perp_day;
}

sub count_to_date {
	local($perp_days) = @_;
	%day_counts =
	  (1,0,2,31,3,59,4,90,5,120,6,151,
	  7,181,8,212,9,243,10,273,11,304,12,334);
	$perp_year = (int(($perp_days-1)/1461))*4;
	$perp_days = $perp_days-(int(($perp_days-1)/1461)*1461);
	if ($perp_days == 1461) {
		$perp_year = 93+$perp_year+3;
		$perp_days = $perp_days-1095;
	}
	else {
		$perp_year = 93+$perp_year+(int(($perp_days-1)/365));
		$perp_days = $perp_days-(int(($perp_days-1)/365)*365);
	}
	foreach $key (sort ({$a <=> $b} keys %day_counts)) {
		$perp_count = $day_counts{$key};
		if ((int(($perp_year-92)/4) eq (($perp_year-92)/4))
		  && ($key>2)) {
			$perp_count++;
		}
		if ($perp_days > $perp_count) {
			$perp_mon = $key;
			$perp_subtract = $perp_count;
		}
	}
	$perp_day = $perp_days-$perp_subtract;
}

sub LockOpen {
	local(*FILE,$lockfilename) = @_;
	unless (-e "$adverts_dir/$lockfilename") {
		open (FILE,">$adverts_dir/$lockfilename");
		print FILE "\n";
		close (FILE);
	}
	open (FILE,"+<$adverts_dir/$lockfilename") || &Error_File($lockfilename);
	if ($UseLocking) {
		local($TrysLeft) = 1500;
		while ($TrysLeft--) {
			select(undef,undef,undef,0.01);
			(flock(FILE,6)) || next;
			last;
		}
		unless ($TrysLeft >= 0) {
			&Error_File($lockfilename);
		}
	}
}

sub LockClose {
	local(*FILE,$lockfilename) = @_;
	close (FILE);
}

sub MasterLockOpen {
	local($TrysLeft) = 1500;
	if ((-e "$adverts_dir/masterlockfile.lok")
	  && ((stat("$adverts_dir/masterlockfile.lok"))[9]+15<$time)) {
		unlink ("$adverts_dir/masterlockfile.lok");
	}
	while ($TrysLeft--) {
		if (-e "$adverts_dir/masterlockfile.lok") {
			select(undef,undef,undef,0.01);
		}
		else {
			open (MASTERLOCKFILE,">$adverts_dir/masterlockfile.lok");
			print MASTERLOCKFILE "\n";
			close (MASTERLOCKFILE);
			last;
		}
	}
	unless ($TrysLeft >= 0) {
		$UseLocking = 1;
		&Error_File(masterlockfile.lok);
	}
}

sub MasterLockClose {
	unlink ("$adverts_dir/masterlockfile.lok");
}

sub commas {
	local($_)=@_;
	1 while s/(.*\d)(\d\d\d)/$1,$2/;
	$_;
}

sub SendMail {
	local($To,$type) = @_;
	return unless $To;
	if ($type eq "admin") {
		$messagesubject = "$ExchangeName: New Account Waiting";
		$messagebody = "A new account, $editad, awaits approval!\n";
	}
	elsif ($type eq "getpass") {
		$messagesubject = "$ExchangeName: Password";
		$messagebody = "The password for the \"$INPUT{'getpass'}\" account ";
		$messagebody .= "is \"$pass\" (case-sensitive).";
	}
	elsif ($type eq "welcome") {
		$messagesubject = "$ExchangeName: Welcome!";
		$messagebody = $body;
	}
	elsif ($type eq "reject") {
		$messagesubject = "$ExchangeName: Account Rejected";
		$messagebody = $body;
	}
	if ($mailprog eq "SMTP") {
		unless ($WEB_SERVER) { $WEB_SERVER = $ENV{'SERVER_NAME'}; }
		if (!$WEB_SERVER) { &Error_Mail; }
		unless ($SMTP_SERVER) {
			$SMTP_SERVER = "smtp.$WEB_SERVER";
			$SMTP_SERVER =~ s/^smtp\.[^.]+\.([^.]+\.)/smtp.$1/;
		}
		local($AF_INET) = ($] > 5 ? AF_INET : 2);
		local($SOCK_STREAM) = ($] > 5 ? SOCK_STREAM : 1);
		$, = ', ';
		$" = ', ';
		local($local_address) = (gethostbyname($WEB_SERVER))[4];
		local($local_socket_address) = pack('S n a4 x8', $AF_INET, 0, $local_address);
		local($server_address) = (gethostbyname($SMTP_SERVER))[4];
		local($server_socket_address) = pack('S n a4 x8', $AF_INET, '25', $server_address);
		local($protocol) = (getprotobyname('tcp'))[2];
		if (!socket(SMTP, $AF_INET, $SOCK_STREAM, $protocol)) { &Error_Mail; }
		bind(SMTP, $local_socket_address);
		if (!(connect(SMTP, $server_socket_address))) { &Error_Mail; }
		local($old_selected) = select(SMTP); 
		$| = 1; 
		select($old_selected);
		$* = 1;
		select(undef, undef, undef, .75);
		sysread(SMTP, $_, 1024);
		print SMTP "HELO $WEB_SERVER\r\n";
		sysread(SMTP, $_, 1024);
		while (/(^|(\r?\n))[^0-9]*((\d\d\d).*)$/g) { 
			$status = $4;
			$message = $3;
		}
		if ($status != 250) { &Error_Mail; }
		print SMTP "MAIL FROM:<$maillist_address>\r\n";
		sysread(SMTP, $_, 1024);
		if (!/[^0-9]*250/) { &Error_Mail; }
		local($good_addresses) = 0;
		$To = "<$To>";
		print SMTP "RCPT TO:$To\r\n";
		sysread(SMTP, $_, 1024);
		/[^0-9]*(\d\d\d)/;
		if ($1 eq '250') { $good_addresses++; }
		if (!$good_addresses) { &Error_Mail; }
		print SMTP "DATA\r\n";
		sysread(SMTP, $_, 1024);
		if (!/[^0-9]*354/) { &Error_Mail; }
		print SMTP "To: $To\r\n";
		print SMTP "From: $email_address\r\n";
		print SMTP "Subject: $messagesubject\r\n\r\n";
		print SMTP "$messagebody";
		print SMTP "\r\n\r\n.\r\n";
		sysread(SMTP, $_, 1024);
		shutdown(SMTP, 2);
	}
	elsif ($mailprog eq "libnet"){
#		$smtp = Net::SMTP->new("$SMTP_SERVER");
#		$smtp->mail( "$maillist_address");
#		$smtp->to("$To");
#		$smtp->data();
#		$smtp->datasend("To: $To\n");
#		$smtp->datasend("From: $email_address\n");
#		$smtp->datasend("Subject: $messagesubject\n\n");
#		$smtp->datasend("$messagebody");
#		$smtp->quit;
	}
	elsif ($mailprog) {
		open (MAIL, "|$mailprog -t") || &Error_Mail;
		print MAIL "To: $To\n";
		print MAIL "From: $email_address\n",
		  "Subject: $messagesubject\n\n",
		  "$messagebody";
		close (MAIL);
	}
}

sub Error_Mail {
	&Header("WebAdverts Error!","Mail System Error!");
	print "<P>The server encountered an error while trying ";
	print "to send out e-mail. This most likely means that ";
	print "the e-mail program has been incorrectly defined ";
	print "in the program's configuration.\n";
	&Footer;
}

sub Error_File {
	&Header("WebAdverts Error!","File Permission Error!");
	print "<P>The server encountered an error while trying ";
	print "to access <STRONG>$_[0]</STRONG>!\n";
	print "<P>The most likely cause of the problem is a permissions ";
	print "error in your adverts directory ($adverts_dir). Make ";
	print "sure that the directory exists and that it is set ";
	print "world-writable.\n";
	&Footer;
}

sub Error_NoStats {
	&Header("WebAdverts Error!","No Daily Stats!");
	print "<P ALIGN=CENTER>";
	print "Sorry, but it seems ";
	print "there is no daily log file available ";
	print "for the $INPUT{'advert'} account!\n";
	&Footer;
}

sub UpdateAdList {
	&LockOpen (COUNT, "adcount.txt");
	@lines = <COUNT>;
	foreach $line (@lines) { chop ($line) if ($line =~ /\n$/); }
	seek (COUNT,0,0);
	print COUNT "$lines[0]\n";
	print COUNT "$lines[1]\n";
	print COUNT "$lines[2]\n";
	$max = @lines - 1;
	@advertisements = @lines[3..$max];
	open (LIST, ">$adverts_dir/adlist.txt");
	foreach $advertiser (@advertisements) {
		next if (length($advertiser) < 1);
		print LIST "$advertiser\n";
	}
	truncate (COUNT, tell(COUNT));
	&LockClose (COUNT,"adcount.txt");
	truncate (LIST, tell(LIST));
	close (LIST);
}
